﻿namespace BizHawk.Emulation.Cores.Computers.Commodore64.MOS
{
	// sid
	static public class MOS6581
	{
		static int[][] waveTable = new int[][]
		{
			new int[] {
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF
			},
			new int[] {
				0x000, 0x002, 0x004, 0x006, 0x008, 0x00A, 0x00C, 0x00E, 
				0x010, 0x012, 0x014, 0x016, 0x018, 0x01A, 0x01C, 0x01E, 
				0x020, 0x022, 0x024, 0x026, 0x028, 0x02A, 0x02C, 0x02E, 
				0x030, 0x032, 0x034, 0x036, 0x038, 0x03A, 0x03C, 0x03E, 
				0x040, 0x042, 0x044, 0x046, 0x048, 0x04A, 0x04C, 0x04E, 
				0x050, 0x052, 0x054, 0x056, 0x058, 0x05A, 0x05C, 0x05E, 
				0x060, 0x062, 0x064, 0x066, 0x068, 0x06A, 0x06C, 0x06E, 
				0x070, 0x072, 0x074, 0x076, 0x078, 0x07A, 0x07C, 0x07E, 
				0x080, 0x082, 0x084, 0x086, 0x088, 0x08A, 0x08C, 0x08E, 
				0x090, 0x092, 0x094, 0x096, 0x098, 0x09A, 0x09C, 0x09E, 
				0x0A0, 0x0A2, 0x0A4, 0x0A6, 0x0A8, 0x0AA, 0x0AC, 0x0AE, 
				0x0B0, 0x0B2, 0x0B4, 0x0B6, 0x0B8, 0x0BA, 0x0BC, 0x0BE, 
				0x0C0, 0x0C2, 0x0C4, 0x0C6, 0x0C8, 0x0CA, 0x0CC, 0x0CE, 
				0x0D0, 0x0D2, 0x0D4, 0x0D6, 0x0D8, 0x0DA, 0x0DC, 0x0DE, 
				0x0E0, 0x0E2, 0x0E4, 0x0E6, 0x0E8, 0x0EA, 0x0EC, 0x0EE, 
				0x0F0, 0x0F2, 0x0F4, 0x0F6, 0x0F8, 0x0FA, 0x0FC, 0x0FE, 
				0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 
				0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 
				0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 
				0x130, 0x132, 0x134, 0x136, 0x138, 0x13A, 0x13C, 0x13E, 
				0x140, 0x142, 0x144, 0x146, 0x148, 0x14A, 0x14C, 0x14E, 
				0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 
				0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 
				0x170, 0x172, 0x174, 0x176, 0x178, 0x17A, 0x17C, 0x17E, 
				0x180, 0x182, 0x184, 0x186, 0x188, 0x18A, 0x18C, 0x18E, 
				0x190, 0x192, 0x194, 0x196, 0x198, 0x19A, 0x19C, 0x19E, 
				0x1A0, 0x1A2, 0x1A4, 0x1A6, 0x1A8, 0x1AA, 0x1AC, 0x1AE, 
				0x1B0, 0x1B2, 0x1B4, 0x1B6, 0x1B8, 0x1BA, 0x1BC, 0x1BE, 
				0x1C0, 0x1C2, 0x1C4, 0x1C6, 0x1C8, 0x1CA, 0x1CC, 0x1CE, 
				0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DC, 0x1DE, 
				0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 
				0x1F0, 0x1F2, 0x1F4, 0x1F6, 0x1F8, 0x1FA, 0x1FC, 0x1FE, 
				0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 
				0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 
				0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 
				0x230, 0x232, 0x234, 0x236, 0x238, 0x23A, 0x23C, 0x23E, 
				0x240, 0x242, 0x244, 0x246, 0x248, 0x24A, 0x24C, 0x24E, 
				0x250, 0x252, 0x254, 0x256, 0x258, 0x25A, 0x25C, 0x25E, 
				0x260, 0x262, 0x264, 0x266, 0x268, 0x26A, 0x26C, 0x26E, 
				0x270, 0x272, 0x274, 0x276, 0x278, 0x27A, 0x27C, 0x27E, 
				0x280, 0x282, 0x284, 0x286, 0x288, 0x28A, 0x28C, 0x28E, 
				0x290, 0x292, 0x294, 0x296, 0x298, 0x29A, 0x29C, 0x29E, 
				0x2A0, 0x2A2, 0x2A4, 0x2A6, 0x2A8, 0x2AA, 0x2AC, 0x2AE, 
				0x2B0, 0x2B2, 0x2B4, 0x2B6, 0x2B8, 0x2BA, 0x2BC, 0x2BE, 
				0x2C0, 0x2C2, 0x2C4, 0x2C6, 0x2C8, 0x2CA, 0x2CC, 0x2CE, 
				0x2D0, 0x2D2, 0x2D4, 0x2D6, 0x2D8, 0x2DA, 0x2DC, 0x2DE, 
				0x2E0, 0x2E2, 0x2E4, 0x2E6, 0x2E8, 0x2EA, 0x2EC, 0x2EE, 
				0x2F0, 0x2F2, 0x2F4, 0x2F6, 0x2F8, 0x2FA, 0x2FC, 0x2FE, 
				0x300, 0x302, 0x304, 0x306, 0x308, 0x30A, 0x30C, 0x30E, 
				0x310, 0x312, 0x314, 0x316, 0x318, 0x31A, 0x31C, 0x31E, 
				0x320, 0x322, 0x324, 0x326, 0x328, 0x32A, 0x32C, 0x32E, 
				0x330, 0x332, 0x334, 0x336, 0x338, 0x33A, 0x33C, 0x33E, 
				0x340, 0x342, 0x344, 0x346, 0x348, 0x34A, 0x34C, 0x34E, 
				0x350, 0x352, 0x354, 0x356, 0x358, 0x35A, 0x35C, 0x35E, 
				0x360, 0x362, 0x364, 0x366, 0x368, 0x36A, 0x36C, 0x36E, 
				0x370, 0x372, 0x374, 0x376, 0x378, 0x37A, 0x37C, 0x37E, 
				0x380, 0x382, 0x384, 0x386, 0x388, 0x38A, 0x38C, 0x38E, 
				0x390, 0x392, 0x394, 0x396, 0x398, 0x39A, 0x39C, 0x39E, 
				0x3A0, 0x3A2, 0x3A4, 0x3A6, 0x3A8, 0x3AA, 0x3AC, 0x3AE, 
				0x3B0, 0x3B2, 0x3B4, 0x3B6, 0x3B8, 0x3BA, 0x3BC, 0x3BE, 
				0x3C0, 0x3C2, 0x3C4, 0x3C6, 0x3C8, 0x3CA, 0x3CC, 0x3CE, 
				0x3D0, 0x3D2, 0x3D4, 0x3D6, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 
				0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 
				0x3F0, 0x3F2, 0x3F4, 0x3F6, 0x3F8, 0x3FA, 0x3FC, 0x3FE, 
				0x400, 0x402, 0x404, 0x406, 0x408, 0x40A, 0x40C, 0x40E, 
				0x410, 0x412, 0x414, 0x416, 0x418, 0x41A, 0x41C, 0x41E, 
				0x420, 0x422, 0x424, 0x426, 0x428, 0x42A, 0x42C, 0x42E, 
				0x430, 0x432, 0x434, 0x436, 0x438, 0x43A, 0x43C, 0x43E, 
				0x440, 0x442, 0x444, 0x446, 0x448, 0x44A, 0x44C, 0x44E, 
				0x450, 0x452, 0x454, 0x456, 0x458, 0x45A, 0x45C, 0x45E, 
				0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 
				0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 
				0x480, 0x482, 0x484, 0x486, 0x488, 0x48A, 0x48C, 0x48E, 
				0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 
				0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 
				0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 
				0x4C0, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4CE, 
				0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 
				0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 
				0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 
				0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 
				0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 
				0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 
				0x530, 0x532, 0x534, 0x536, 0x538, 0x53A, 0x53C, 0x53E, 
				0x540, 0x542, 0x544, 0x546, 0x548, 0x54A, 0x54C, 0x54E, 
				0x550, 0x552, 0x554, 0x556, 0x558, 0x55A, 0x55C, 0x55E, 
				0x560, 0x562, 0x564, 0x566, 0x568, 0x56A, 0x56C, 0x56E, 
				0x570, 0x572, 0x574, 0x576, 0x578, 0x57A, 0x57C, 0x57E, 
				0x580, 0x582, 0x584, 0x586, 0x588, 0x58A, 0x58C, 0x58E, 
				0x590, 0x592, 0x594, 0x596, 0x598, 0x59A, 0x59C, 0x59E, 
				0x5A0, 0x5A2, 0x5A4, 0x5A6, 0x5A8, 0x5AA, 0x5AC, 0x5AE, 
				0x5B0, 0x5B2, 0x5B4, 0x5B6, 0x5B8, 0x5BA, 0x5BC, 0x5BE, 
				0x5C0, 0x5C2, 0x5C4, 0x5C6, 0x5C8, 0x5CA, 0x5CC, 0x5CE, 
				0x5D0, 0x5D2, 0x5D4, 0x5D6, 0x5D8, 0x5DA, 0x5DC, 0x5DE, 
				0x5E0, 0x5E2, 0x5E4, 0x5E6, 0x5E8, 0x5EA, 0x5EC, 0x5EE, 
				0x5F0, 0x5F2, 0x5F4, 0x5F6, 0x5F8, 0x5FA, 0x5FC, 0x5FE, 
				0x600, 0x602, 0x604, 0x606, 0x608, 0x60A, 0x60C, 0x60E, 
				0x610, 0x612, 0x614, 0x616, 0x618, 0x61A, 0x61C, 0x61E, 
				0x620, 0x622, 0x624, 0x626, 0x628, 0x62A, 0x62C, 0x62E, 
				0x630, 0x632, 0x634, 0x636, 0x638, 0x63A, 0x63C, 0x63E, 
				0x640, 0x642, 0x644, 0x646, 0x648, 0x64A, 0x64C, 0x64E, 
				0x650, 0x652, 0x654, 0x656, 0x658, 0x65A, 0x65C, 0x65E, 
				0x660, 0x662, 0x664, 0x666, 0x668, 0x66A, 0x66C, 0x66E, 
				0x670, 0x672, 0x674, 0x676, 0x678, 0x67A, 0x67C, 0x67E, 
				0x680, 0x682, 0x684, 0x686, 0x688, 0x68A, 0x68C, 0x68E, 
				0x690, 0x692, 0x694, 0x696, 0x698, 0x69A, 0x69C, 0x69E, 
				0x6A0, 0x6A2, 0x6A4, 0x6A6, 0x6A8, 0x6AA, 0x6AC, 0x6AE, 
				0x6B0, 0x6B2, 0x6B4, 0x6B6, 0x6B8, 0x6BA, 0x6BC, 0x6BE, 
				0x6C0, 0x6C2, 0x6C4, 0x6C6, 0x6C8, 0x6CA, 0x6CC, 0x6CE, 
				0x6D0, 0x6D2, 0x6D4, 0x6D6, 0x6D8, 0x6DA, 0x6DC, 0x6DE, 
				0x6E0, 0x6E2, 0x6E4, 0x6E6, 0x6E8, 0x6EA, 0x6EC, 0x6EE, 
				0x6F0, 0x6F2, 0x6F4, 0x6F6, 0x6F8, 0x6FA, 0x6FC, 0x6FE, 
				0x700, 0x702, 0x704, 0x706, 0x708, 0x70A, 0x70C, 0x70E, 
				0x710, 0x712, 0x714, 0x716, 0x718, 0x71A, 0x71C, 0x71E, 
				0x720, 0x722, 0x724, 0x726, 0x728, 0x72A, 0x72C, 0x72E, 
				0x730, 0x732, 0x734, 0x736, 0x738, 0x73A, 0x73C, 0x73E, 
				0x740, 0x742, 0x744, 0x746, 0x748, 0x74A, 0x74C, 0x74E, 
				0x750, 0x752, 0x754, 0x756, 0x758, 0x75A, 0x75C, 0x75E, 
				0x760, 0x762, 0x764, 0x766, 0x768, 0x76A, 0x76C, 0x76E, 
				0x770, 0x772, 0x774, 0x776, 0x778, 0x77A, 0x77C, 0x77E, 
				0x780, 0x782, 0x784, 0x786, 0x788, 0x78A, 0x78C, 0x78E, 
				0x790, 0x792, 0x794, 0x796, 0x798, 0x79A, 0x79C, 0x79E, 
				0x7A0, 0x7A2, 0x7A4, 0x7A6, 0x7A8, 0x7AA, 0x7AC, 0x7AE, 
				0x7B0, 0x7B2, 0x7B4, 0x7B6, 0x7B8, 0x7BA, 0x7BC, 0x7BE, 
				0x7C0, 0x7C2, 0x7C4, 0x7C6, 0x7C8, 0x7CA, 0x7CC, 0x7CE, 
				0x7D0, 0x7D2, 0x7D4, 0x7D6, 0x7D8, 0x7DA, 0x7DC, 0x7DE, 
				0x7E0, 0x7E2, 0x7E4, 0x7E6, 0x7E8, 0x7EA, 0x7EC, 0x7EE, 
				0x7F0, 0x7F2, 0x7F4, 0x7F6, 0x7F8, 0x7FA, 0x7FC, 0x7FE, 
				0x800, 0x802, 0x804, 0x806, 0x808, 0x80A, 0x80C, 0x80E, 
				0x810, 0x812, 0x814, 0x816, 0x818, 0x81A, 0x81C, 0x81E, 
				0x820, 0x822, 0x824, 0x826, 0x828, 0x82A, 0x82C, 0x82E, 
				0x830, 0x832, 0x834, 0x836, 0x838, 0x83A, 0x83C, 0x83E, 
				0x840, 0x842, 0x844, 0x846, 0x848, 0x84A, 0x84C, 0x84E, 
				0x850, 0x852, 0x854, 0x856, 0x858, 0x85A, 0x85C, 0x85E, 
				0x860, 0x862, 0x864, 0x866, 0x868, 0x86A, 0x86C, 0x86E, 
				0x870, 0x872, 0x874, 0x876, 0x878, 0x87A, 0x87C, 0x87E, 
				0x880, 0x882, 0x884, 0x886, 0x888, 0x88A, 0x88C, 0x88E, 
				0x890, 0x892, 0x894, 0x896, 0x898, 0x89A, 0x89C, 0x89E, 
				0x8A0, 0x8A2, 0x8A4, 0x8A6, 0x8A8, 0x8AA, 0x8AC, 0x8AE, 
				0x8B0, 0x8B2, 0x8B4, 0x8B6, 0x8B8, 0x8BA, 0x8BC, 0x8BE, 
				0x8C0, 0x8C2, 0x8C4, 0x8C6, 0x8C8, 0x8CA, 0x8CC, 0x8CE, 
				0x8D0, 0x8D2, 0x8D4, 0x8D6, 0x8D8, 0x8DA, 0x8DC, 0x8DE, 
				0x8E0, 0x8E2, 0x8E4, 0x8E6, 0x8E8, 0x8EA, 0x8EC, 0x8EE, 
				0x8F0, 0x8F2, 0x8F4, 0x8F6, 0x8F8, 0x8FA, 0x8FC, 0x8FE, 
				0x900, 0x902, 0x904, 0x906, 0x908, 0x90A, 0x90C, 0x90E, 
				0x910, 0x912, 0x914, 0x916, 0x918, 0x91A, 0x91C, 0x91E, 
				0x920, 0x922, 0x924, 0x926, 0x928, 0x92A, 0x92C, 0x92E, 
				0x930, 0x932, 0x934, 0x936, 0x938, 0x93A, 0x93C, 0x93E, 
				0x940, 0x942, 0x944, 0x946, 0x948, 0x94A, 0x94C, 0x94E, 
				0x950, 0x952, 0x954, 0x956, 0x958, 0x95A, 0x95C, 0x95E, 
				0x960, 0x962, 0x964, 0x966, 0x968, 0x96A, 0x96C, 0x96E, 
				0x970, 0x972, 0x974, 0x976, 0x978, 0x97A, 0x97C, 0x97E, 
				0x980, 0x982, 0x984, 0x986, 0x988, 0x98A, 0x98C, 0x98E, 
				0x990, 0x992, 0x994, 0x996, 0x998, 0x99A, 0x99C, 0x99E, 
				0x9A0, 0x9A2, 0x9A4, 0x9A6, 0x9A8, 0x9AA, 0x9AC, 0x9AE, 
				0x9B0, 0x9B2, 0x9B4, 0x9B6, 0x9B8, 0x9BA, 0x9BC, 0x9BE, 
				0x9C0, 0x9C2, 0x9C4, 0x9C6, 0x9C8, 0x9CA, 0x9CC, 0x9CE, 
				0x9D0, 0x9D2, 0x9D4, 0x9D6, 0x9D8, 0x9DA, 0x9DC, 0x9DE, 
				0x9E0, 0x9E2, 0x9E4, 0x9E6, 0x9E8, 0x9EA, 0x9EC, 0x9EE, 
				0x9F0, 0x9F2, 0x9F4, 0x9F6, 0x9F8, 0x9FA, 0x9FC, 0x9FE, 
				0xA00, 0xA02, 0xA04, 0xA06, 0xA08, 0xA0A, 0xA0C, 0xA0E, 
				0xA10, 0xA12, 0xA14, 0xA16, 0xA18, 0xA1A, 0xA1C, 0xA1E, 
				0xA20, 0xA22, 0xA24, 0xA26, 0xA28, 0xA2A, 0xA2C, 0xA2E, 
				0xA30, 0xA32, 0xA34, 0xA36, 0xA38, 0xA3A, 0xA3C, 0xA3E, 
				0xA40, 0xA42, 0xA44, 0xA46, 0xA48, 0xA4A, 0xA4C, 0xA4E, 
				0xA50, 0xA52, 0xA54, 0xA56, 0xA58, 0xA5A, 0xA5C, 0xA5E, 
				0xA60, 0xA62, 0xA64, 0xA66, 0xA68, 0xA6A, 0xA6C, 0xA6E, 
				0xA70, 0xA72, 0xA74, 0xA76, 0xA78, 0xA7A, 0xA7C, 0xA7E, 
				0xA80, 0xA82, 0xA84, 0xA86, 0xA88, 0xA8A, 0xA8C, 0xA8E, 
				0xA90, 0xA92, 0xA94, 0xA96, 0xA98, 0xA9A, 0xA9C, 0xA9E, 
				0xAA0, 0xAA2, 0xAA4, 0xAA6, 0xAA8, 0xAAA, 0xAAC, 0xAAE, 
				0xAB0, 0xAB2, 0xAB4, 0xAB6, 0xAB8, 0xABA, 0xABC, 0xABE, 
				0xAC0, 0xAC2, 0xAC4, 0xAC6, 0xAC8, 0xACA, 0xACC, 0xACE, 
				0xAD0, 0xAD2, 0xAD4, 0xAD6, 0xAD8, 0xADA, 0xADC, 0xADE, 
				0xAE0, 0xAE2, 0xAE4, 0xAE6, 0xAE8, 0xAEA, 0xAEC, 0xAEE, 
				0xAF0, 0xAF2, 0xAF4, 0xAF6, 0xAF8, 0xAFA, 0xAFC, 0xAFE, 
				0xB00, 0xB02, 0xB04, 0xB06, 0xB08, 0xB0A, 0xB0C, 0xB0E, 
				0xB10, 0xB12, 0xB14, 0xB16, 0xB18, 0xB1A, 0xB1C, 0xB1E, 
				0xB20, 0xB22, 0xB24, 0xB26, 0xB28, 0xB2A, 0xB2C, 0xB2E, 
				0xB30, 0xB32, 0xB34, 0xB36, 0xB38, 0xB3A, 0xB3C, 0xB3E, 
				0xB40, 0xB42, 0xB44, 0xB46, 0xB48, 0xB4A, 0xB4C, 0xB4E, 
				0xB50, 0xB52, 0xB54, 0xB56, 0xB58, 0xB5A, 0xB5C, 0xB5E, 
				0xB60, 0xB62, 0xB64, 0xB66, 0xB68, 0xB6A, 0xB6C, 0xB6E, 
				0xB70, 0xB72, 0xB74, 0xB76, 0xB78, 0xB7A, 0xB7C, 0xB7E, 
				0xB80, 0xB82, 0xB84, 0xB86, 0xB88, 0xB8A, 0xB8C, 0xB8E, 
				0xB90, 0xB92, 0xB94, 0xB96, 0xB98, 0xB9A, 0xB9C, 0xB9E, 
				0xBA0, 0xBA2, 0xBA4, 0xBA6, 0xBA8, 0xBAA, 0xBAC, 0xBAE, 
				0xBB0, 0xBB2, 0xBB4, 0xBB6, 0xBB8, 0xBBA, 0xBBC, 0xBBE, 
				0xBC0, 0xBC2, 0xBC4, 0xBC6, 0xBC8, 0xBCA, 0xBCC, 0xBCE, 
				0xBD0, 0xBD2, 0xBD4, 0xBD6, 0xBD8, 0xBDA, 0xBDC, 0xBDE, 
				0xBE0, 0xBE2, 0xBE4, 0xBE6, 0xBE8, 0xBEA, 0xBEC, 0xBEE, 
				0xBF0, 0xBF2, 0xBF4, 0xBF6, 0xBF8, 0xBFA, 0xBFC, 0xBFE, 
				0xC00, 0xC02, 0xC04, 0xC06, 0xC08, 0xC0A, 0xC0C, 0xC0E, 
				0xC10, 0xC12, 0xC14, 0xC16, 0xC18, 0xC1A, 0xC1C, 0xC1E, 
				0xC20, 0xC22, 0xC24, 0xC26, 0xC28, 0xC2A, 0xC2C, 0xC2E, 
				0xC30, 0xC32, 0xC34, 0xC36, 0xC38, 0xC3A, 0xC3C, 0xC3E, 
				0xC40, 0xC42, 0xC44, 0xC46, 0xC48, 0xC4A, 0xC4C, 0xC4E, 
				0xC50, 0xC52, 0xC54, 0xC56, 0xC58, 0xC5A, 0xC5C, 0xC5E, 
				0xC60, 0xC62, 0xC64, 0xC66, 0xC68, 0xC6A, 0xC6C, 0xC6E, 
				0xC70, 0xC72, 0xC74, 0xC76, 0xC78, 0xC7A, 0xC7C, 0xC7E, 
				0xC80, 0xC82, 0xC84, 0xC86, 0xC88, 0xC8A, 0xC8C, 0xC8E, 
				0xC90, 0xC92, 0xC94, 0xC96, 0xC98, 0xC9A, 0xC9C, 0xC9E, 
				0xCA0, 0xCA2, 0xCA4, 0xCA6, 0xCA8, 0xCAA, 0xCAC, 0xCAE, 
				0xCB0, 0xCB2, 0xCB4, 0xCB6, 0xCB8, 0xCBA, 0xCBC, 0xCBE, 
				0xCC0, 0xCC2, 0xCC4, 0xCC6, 0xCC8, 0xCCA, 0xCCC, 0xCCE, 
				0xCD0, 0xCD2, 0xCD4, 0xCD6, 0xCD8, 0xCDA, 0xCDC, 0xCDE, 
				0xCE0, 0xCE2, 0xCE4, 0xCE6, 0xCE8, 0xCEA, 0xCEC, 0xCEE, 
				0xCF0, 0xCF2, 0xCF4, 0xCF6, 0xCF8, 0xCFA, 0xCFC, 0xCFE, 
				0xD00, 0xD02, 0xD04, 0xD06, 0xD08, 0xD0A, 0xD0C, 0xD0E, 
				0xD10, 0xD12, 0xD14, 0xD16, 0xD18, 0xD1A, 0xD1C, 0xD1E, 
				0xD20, 0xD22, 0xD24, 0xD26, 0xD28, 0xD2A, 0xD2C, 0xD2E, 
				0xD30, 0xD32, 0xD34, 0xD36, 0xD38, 0xD3A, 0xD3C, 0xD3E, 
				0xD40, 0xD42, 0xD44, 0xD46, 0xD48, 0xD4A, 0xD4C, 0xD4E, 
				0xD50, 0xD52, 0xD54, 0xD56, 0xD58, 0xD5A, 0xD5C, 0xD5E, 
				0xD60, 0xD62, 0xD64, 0xD66, 0xD68, 0xD6A, 0xD6C, 0xD6E, 
				0xD70, 0xD72, 0xD74, 0xD76, 0xD78, 0xD7A, 0xD7C, 0xD7E, 
				0xD80, 0xD82, 0xD84, 0xD86, 0xD88, 0xD8A, 0xD8C, 0xD8E, 
				0xD90, 0xD92, 0xD94, 0xD96, 0xD98, 0xD9A, 0xD9C, 0xD9E, 
				0xDA0, 0xDA2, 0xDA4, 0xDA6, 0xDA8, 0xDAA, 0xDAC, 0xDAE, 
				0xDB0, 0xDB2, 0xDB4, 0xDB6, 0xDB8, 0xDBA, 0xDBC, 0xDBE, 
				0xDC0, 0xDC2, 0xDC4, 0xDC6, 0xDC8, 0xDCA, 0xDCC, 0xDCE, 
				0xDD0, 0xDD2, 0xDD4, 0xDD6, 0xDD8, 0xDDA, 0xDDC, 0xDDE, 
				0xDE0, 0xDE2, 0xDE4, 0xDE6, 0xDE8, 0xDEA, 0xDEC, 0xDEE, 
				0xDF0, 0xDF2, 0xDF4, 0xDF6, 0xDF8, 0xDFA, 0xDFC, 0xDFE, 
				0xE00, 0xE02, 0xE04, 0xE06, 0xE08, 0xE0A, 0xE0C, 0xE0E, 
				0xE10, 0xE12, 0xE14, 0xE16, 0xE18, 0xE1A, 0xE1C, 0xE1E, 
				0xE20, 0xE22, 0xE24, 0xE26, 0xE28, 0xE2A, 0xE2C, 0xE2E, 
				0xE30, 0xE32, 0xE34, 0xE36, 0xE38, 0xE3A, 0xE3C, 0xE3E, 
				0xE40, 0xE42, 0xE44, 0xE46, 0xE48, 0xE4A, 0xE4C, 0xE4E, 
				0xE50, 0xE52, 0xE54, 0xE56, 0xE58, 0xE5A, 0xE5C, 0xE5E, 
				0xE60, 0xE62, 0xE64, 0xE66, 0xE68, 0xE6A, 0xE6C, 0xE6E, 
				0xE70, 0xE72, 0xE74, 0xE76, 0xE78, 0xE7A, 0xE7C, 0xE7E, 
				0xE80, 0xE82, 0xE84, 0xE86, 0xE88, 0xE8A, 0xE8C, 0xE8E, 
				0xE90, 0xE92, 0xE94, 0xE96, 0xE98, 0xE9A, 0xE9C, 0xE9E, 
				0xEA0, 0xEA2, 0xEA4, 0xEA6, 0xEA8, 0xEAA, 0xEAC, 0xEAE, 
				0xEB0, 0xEB2, 0xEB4, 0xEB6, 0xEB8, 0xEBA, 0xEBC, 0xEBE, 
				0xEC0, 0xEC2, 0xEC4, 0xEC6, 0xEC8, 0xECA, 0xECC, 0xECE, 
				0xED0, 0xED2, 0xED4, 0xED6, 0xED8, 0xEDA, 0xEDC, 0xEDE, 
				0xEE0, 0xEE2, 0xEE4, 0xEE6, 0xEE8, 0xEEA, 0xEEC, 0xEEE, 
				0xEF0, 0xEF2, 0xEF4, 0xEF6, 0xEF8, 0xEFA, 0xEFC, 0xEFE, 
				0xF00, 0xF02, 0xF04, 0xF06, 0xF08, 0xF0A, 0xF0C, 0xF0E, 
				0xF10, 0xF12, 0xF14, 0xF16, 0xF18, 0xF1A, 0xF1C, 0xF1E, 
				0xF20, 0xF22, 0xF24, 0xF26, 0xF28, 0xF2A, 0xF2C, 0xF2E, 
				0xF30, 0xF32, 0xF34, 0xF36, 0xF38, 0xF3A, 0xF3C, 0xF3E, 
				0xF40, 0xF42, 0xF44, 0xF46, 0xF48, 0xF4A, 0xF4C, 0xF4E, 
				0xF50, 0xF52, 0xF54, 0xF56, 0xF58, 0xF5A, 0xF5C, 0xF5E, 
				0xF60, 0xF62, 0xF64, 0xF66, 0xF68, 0xF6A, 0xF6C, 0xF6E, 
				0xF70, 0xF72, 0xF74, 0xF76, 0xF78, 0xF7A, 0xF7C, 0xF7E, 
				0xF80, 0xF82, 0xF84, 0xF86, 0xF88, 0xF8A, 0xF8C, 0xF8E, 
				0xF90, 0xF92, 0xF94, 0xF96, 0xF98, 0xF9A, 0xF9C, 0xF9E, 
				0xFA0, 0xFA2, 0xFA4, 0xFA6, 0xFA8, 0xFAA, 0xFAC, 0xFAE, 
				0xFB0, 0xFB2, 0xFB4, 0xFB6, 0xFB8, 0xFBA, 0xFBC, 0xFBE, 
				0xFC0, 0xFC2, 0xFC4, 0xFC6, 0xFC8, 0xFCA, 0xFCC, 0xFCE, 
				0xFD0, 0xFD2, 0xFD4, 0xFD6, 0xFD8, 0xFDA, 0xFDC, 0xFDE, 
				0xFE0, 0xFE2, 0xFE4, 0xFE6, 0xFE8, 0xFEA, 0xFEC, 0xFEE, 
				0xFF0, 0xFF2, 0xFF4, 0xFF6, 0xFF8, 0xFFA, 0xFFC, 0xFFE, 
				0xFFE, 0xFFC, 0xFFA, 0xFF8, 0xFF6, 0xFF4, 0xFF2, 0xFF0, 
				0xFEE, 0xFEC, 0xFEA, 0xFE8, 0xFE6, 0xFE4, 0xFE2, 0xFE0, 
				0xFDE, 0xFDC, 0xFDA, 0xFD8, 0xFD6, 0xFD4, 0xFD2, 0xFD0, 
				0xFCE, 0xFCC, 0xFCA, 0xFC8, 0xFC6, 0xFC4, 0xFC2, 0xFC0, 
				0xFBE, 0xFBC, 0xFBA, 0xFB8, 0xFB6, 0xFB4, 0xFB2, 0xFB0, 
				0xFAE, 0xFAC, 0xFAA, 0xFA8, 0xFA6, 0xFA4, 0xFA2, 0xFA0, 
				0xF9E, 0xF9C, 0xF9A, 0xF98, 0xF96, 0xF94, 0xF92, 0xF90, 
				0xF8E, 0xF8C, 0xF8A, 0xF88, 0xF86, 0xF84, 0xF82, 0xF80, 
				0xF7E, 0xF7C, 0xF7A, 0xF78, 0xF76, 0xF74, 0xF72, 0xF70, 
				0xF6E, 0xF6C, 0xF6A, 0xF68, 0xF66, 0xF64, 0xF62, 0xF60, 
				0xF5E, 0xF5C, 0xF5A, 0xF58, 0xF56, 0xF54, 0xF52, 0xF50, 
				0xF4E, 0xF4C, 0xF4A, 0xF48, 0xF46, 0xF44, 0xF42, 0xF40, 
				0xF3E, 0xF3C, 0xF3A, 0xF38, 0xF36, 0xF34, 0xF32, 0xF30, 
				0xF2E, 0xF2C, 0xF2A, 0xF28, 0xF26, 0xF24, 0xF22, 0xF20, 
				0xF1E, 0xF1C, 0xF1A, 0xF18, 0xF16, 0xF14, 0xF12, 0xF10, 
				0xF0E, 0xF0C, 0xF0A, 0xF08, 0xF06, 0xF04, 0xF02, 0xF00, 
				0xEFE, 0xEFC, 0xEFA, 0xEF8, 0xEF6, 0xEF4, 0xEF2, 0xEF0, 
				0xEEE, 0xEEC, 0xEEA, 0xEE8, 0xEE6, 0xEE4, 0xEE2, 0xEE0, 
				0xEDE, 0xEDC, 0xEDA, 0xED8, 0xED6, 0xED4, 0xED2, 0xED0, 
				0xECE, 0xECC, 0xECA, 0xEC8, 0xEC6, 0xEC4, 0xEC2, 0xEC0, 
				0xEBE, 0xEBC, 0xEBA, 0xEB8, 0xEB6, 0xEB4, 0xEB2, 0xEB0, 
				0xEAE, 0xEAC, 0xEAA, 0xEA8, 0xEA6, 0xEA4, 0xEA2, 0xEA0, 
				0xE9E, 0xE9C, 0xE9A, 0xE98, 0xE96, 0xE94, 0xE92, 0xE90, 
				0xE8E, 0xE8C, 0xE8A, 0xE88, 0xE86, 0xE84, 0xE82, 0xE80, 
				0xE7E, 0xE7C, 0xE7A, 0xE78, 0xE76, 0xE74, 0xE72, 0xE70, 
				0xE6E, 0xE6C, 0xE6A, 0xE68, 0xE66, 0xE64, 0xE62, 0xE60, 
				0xE5E, 0xE5C, 0xE5A, 0xE58, 0xE56, 0xE54, 0xE52, 0xE50, 
				0xE4E, 0xE4C, 0xE4A, 0xE48, 0xE46, 0xE44, 0xE42, 0xE40, 
				0xE3E, 0xE3C, 0xE3A, 0xE38, 0xE36, 0xE34, 0xE32, 0xE30, 
				0xE2E, 0xE2C, 0xE2A, 0xE28, 0xE26, 0xE24, 0xE22, 0xE20, 
				0xE1E, 0xE1C, 0xE1A, 0xE18, 0xE16, 0xE14, 0xE12, 0xE10, 
				0xE0E, 0xE0C, 0xE0A, 0xE08, 0xE06, 0xE04, 0xE02, 0xE00, 
				0xDFE, 0xDFC, 0xDFA, 0xDF8, 0xDF6, 0xDF4, 0xDF2, 0xDF0, 
				0xDEE, 0xDEC, 0xDEA, 0xDE8, 0xDE6, 0xDE4, 0xDE2, 0xDE0, 
				0xDDE, 0xDDC, 0xDDA, 0xDD8, 0xDD6, 0xDD4, 0xDD2, 0xDD0, 
				0xDCE, 0xDCC, 0xDCA, 0xDC8, 0xDC6, 0xDC4, 0xDC2, 0xDC0, 
				0xDBE, 0xDBC, 0xDBA, 0xDB8, 0xDB6, 0xDB4, 0xDB2, 0xDB0, 
				0xDAE, 0xDAC, 0xDAA, 0xDA8, 0xDA6, 0xDA4, 0xDA2, 0xDA0, 
				0xD9E, 0xD9C, 0xD9A, 0xD98, 0xD96, 0xD94, 0xD92, 0xD90, 
				0xD8E, 0xD8C, 0xD8A, 0xD88, 0xD86, 0xD84, 0xD82, 0xD80, 
				0xD7E, 0xD7C, 0xD7A, 0xD78, 0xD76, 0xD74, 0xD72, 0xD70, 
				0xD6E, 0xD6C, 0xD6A, 0xD68, 0xD66, 0xD64, 0xD62, 0xD60, 
				0xD5E, 0xD5C, 0xD5A, 0xD58, 0xD56, 0xD54, 0xD52, 0xD50, 
				0xD4E, 0xD4C, 0xD4A, 0xD48, 0xD46, 0xD44, 0xD42, 0xD40, 
				0xD3E, 0xD3C, 0xD3A, 0xD38, 0xD36, 0xD34, 0xD32, 0xD30, 
				0xD2E, 0xD2C, 0xD2A, 0xD28, 0xD26, 0xD24, 0xD22, 0xD20, 
				0xD1E, 0xD1C, 0xD1A, 0xD18, 0xD16, 0xD14, 0xD12, 0xD10, 
				0xD0E, 0xD0C, 0xD0A, 0xD08, 0xD06, 0xD04, 0xD02, 0xD00, 
				0xCFE, 0xCFC, 0xCFA, 0xCF8, 0xCF6, 0xCF4, 0xCF2, 0xCF0, 
				0xCEE, 0xCEC, 0xCEA, 0xCE8, 0xCE6, 0xCE4, 0xCE2, 0xCE0, 
				0xCDE, 0xCDC, 0xCDA, 0xCD8, 0xCD6, 0xCD4, 0xCD2, 0xCD0, 
				0xCCE, 0xCCC, 0xCCA, 0xCC8, 0xCC6, 0xCC4, 0xCC2, 0xCC0, 
				0xCBE, 0xCBC, 0xCBA, 0xCB8, 0xCB6, 0xCB4, 0xCB2, 0xCB0, 
				0xCAE, 0xCAC, 0xCAA, 0xCA8, 0xCA6, 0xCA4, 0xCA2, 0xCA0, 
				0xC9E, 0xC9C, 0xC9A, 0xC98, 0xC96, 0xC94, 0xC92, 0xC90, 
				0xC8E, 0xC8C, 0xC8A, 0xC88, 0xC86, 0xC84, 0xC82, 0xC80, 
				0xC7E, 0xC7C, 0xC7A, 0xC78, 0xC76, 0xC74, 0xC72, 0xC70, 
				0xC6E, 0xC6C, 0xC6A, 0xC68, 0xC66, 0xC64, 0xC62, 0xC60, 
				0xC5E, 0xC5C, 0xC5A, 0xC58, 0xC56, 0xC54, 0xC52, 0xC50, 
				0xC4E, 0xC4C, 0xC4A, 0xC48, 0xC46, 0xC44, 0xC42, 0xC40, 
				0xC3E, 0xC3C, 0xC3A, 0xC38, 0xC36, 0xC34, 0xC32, 0xC30, 
				0xC2E, 0xC2C, 0xC2A, 0xC28, 0xC26, 0xC24, 0xC22, 0xC20, 
				0xC1E, 0xC1C, 0xC1A, 0xC18, 0xC16, 0xC14, 0xC12, 0xC10, 
				0xC0E, 0xC0C, 0xC0A, 0xC08, 0xC06, 0xC04, 0xC02, 0xC00, 
				0xBFE, 0xBFC, 0xBFA, 0xBF8, 0xBF6, 0xBF4, 0xBF2, 0xBF0, 
				0xBEE, 0xBEC, 0xBEA, 0xBE8, 0xBE6, 0xBE4, 0xBE2, 0xBE0, 
				0xBDE, 0xBDC, 0xBDA, 0xBD8, 0xBD6, 0xBD4, 0xBD2, 0xBD0, 
				0xBCE, 0xBCC, 0xBCA, 0xBC8, 0xBC6, 0xBC4, 0xBC2, 0xBC0, 
				0xBBE, 0xBBC, 0xBBA, 0xBB8, 0xBB6, 0xBB4, 0xBB2, 0xBB0, 
				0xBAE, 0xBAC, 0xBAA, 0xBA8, 0xBA6, 0xBA4, 0xBA2, 0xBA0, 
				0xB9E, 0xB9C, 0xB9A, 0xB98, 0xB96, 0xB94, 0xB92, 0xB90, 
				0xB8E, 0xB8C, 0xB8A, 0xB88, 0xB86, 0xB84, 0xB82, 0xB80, 
				0xB7E, 0xB7C, 0xB7A, 0xB78, 0xB76, 0xB74, 0xB72, 0xB70, 
				0xB6E, 0xB6C, 0xB6A, 0xB68, 0xB66, 0xB64, 0xB62, 0xB60, 
				0xB5E, 0xB5C, 0xB5A, 0xB58, 0xB56, 0xB54, 0xB52, 0xB50, 
				0xB4E, 0xB4C, 0xB4A, 0xB48, 0xB46, 0xB44, 0xB42, 0xB40, 
				0xB3E, 0xB3C, 0xB3A, 0xB38, 0xB36, 0xB34, 0xB32, 0xB30, 
				0xB2E, 0xB2C, 0xB2A, 0xB28, 0xB26, 0xB24, 0xB22, 0xB20, 
				0xB1E, 0xB1C, 0xB1A, 0xB18, 0xB16, 0xB14, 0xB12, 0xB10, 
				0xB0E, 0xB0C, 0xB0A, 0xB08, 0xB06, 0xB04, 0xB02, 0xB00, 
				0xAFE, 0xAFC, 0xAFA, 0xAF8, 0xAF6, 0xAF4, 0xAF2, 0xAF0, 
				0xAEE, 0xAEC, 0xAEA, 0xAE8, 0xAE6, 0xAE4, 0xAE2, 0xAE0, 
				0xADE, 0xADC, 0xADA, 0xAD8, 0xAD6, 0xAD4, 0xAD2, 0xAD0, 
				0xACE, 0xACC, 0xACA, 0xAC8, 0xAC6, 0xAC4, 0xAC2, 0xAC0, 
				0xABE, 0xABC, 0xABA, 0xAB8, 0xAB6, 0xAB4, 0xAB2, 0xAB0, 
				0xAAE, 0xAAC, 0xAAA, 0xAA8, 0xAA6, 0xAA4, 0xAA2, 0xAA0, 
				0xA9E, 0xA9C, 0xA9A, 0xA98, 0xA96, 0xA94, 0xA92, 0xA90, 
				0xA8E, 0xA8C, 0xA8A, 0xA88, 0xA86, 0xA84, 0xA82, 0xA80, 
				0xA7E, 0xA7C, 0xA7A, 0xA78, 0xA76, 0xA74, 0xA72, 0xA70, 
				0xA6E, 0xA6C, 0xA6A, 0xA68, 0xA66, 0xA64, 0xA62, 0xA60, 
				0xA5E, 0xA5C, 0xA5A, 0xA58, 0xA56, 0xA54, 0xA52, 0xA50, 
				0xA4E, 0xA4C, 0xA4A, 0xA48, 0xA46, 0xA44, 0xA42, 0xA40, 
				0xA3E, 0xA3C, 0xA3A, 0xA38, 0xA36, 0xA34, 0xA32, 0xA30, 
				0xA2E, 0xA2C, 0xA2A, 0xA28, 0xA26, 0xA24, 0xA22, 0xA20, 
				0xA1E, 0xA1C, 0xA1A, 0xA18, 0xA16, 0xA14, 0xA12, 0xA10, 
				0xA0E, 0xA0C, 0xA0A, 0xA08, 0xA06, 0xA04, 0xA02, 0xA00, 
				0x9FE, 0x9FC, 0x9FA, 0x9F8, 0x9F6, 0x9F4, 0x9F2, 0x9F0, 
				0x9EE, 0x9EC, 0x9EA, 0x9E8, 0x9E6, 0x9E4, 0x9E2, 0x9E0, 
				0x9DE, 0x9DC, 0x9DA, 0x9D8, 0x9D6, 0x9D4, 0x9D2, 0x9D0, 
				0x9CE, 0x9CC, 0x9CA, 0x9C8, 0x9C6, 0x9C4, 0x9C2, 0x9C0, 
				0x9BE, 0x9BC, 0x9BA, 0x9B8, 0x9B6, 0x9B4, 0x9B2, 0x9B0, 
				0x9AE, 0x9AC, 0x9AA, 0x9A8, 0x9A6, 0x9A4, 0x9A2, 0x9A0, 
				0x99E, 0x99C, 0x99A, 0x998, 0x996, 0x994, 0x992, 0x990, 
				0x98E, 0x98C, 0x98A, 0x988, 0x986, 0x984, 0x982, 0x980, 
				0x97E, 0x97C, 0x97A, 0x978, 0x976, 0x974, 0x972, 0x970, 
				0x96E, 0x96C, 0x96A, 0x968, 0x966, 0x964, 0x962, 0x960, 
				0x95E, 0x95C, 0x95A, 0x958, 0x956, 0x954, 0x952, 0x950, 
				0x94E, 0x94C, 0x94A, 0x948, 0x946, 0x944, 0x942, 0x940, 
				0x93E, 0x93C, 0x93A, 0x938, 0x936, 0x934, 0x932, 0x930, 
				0x92E, 0x92C, 0x92A, 0x928, 0x926, 0x924, 0x922, 0x920, 
				0x91E, 0x91C, 0x91A, 0x918, 0x916, 0x914, 0x912, 0x910, 
				0x90E, 0x90C, 0x90A, 0x908, 0x906, 0x904, 0x902, 0x900, 
				0x8FE, 0x8FC, 0x8FA, 0x8F8, 0x8F6, 0x8F4, 0x8F2, 0x8F0, 
				0x8EE, 0x8EC, 0x8EA, 0x8E8, 0x8E6, 0x8E4, 0x8E2, 0x8E0, 
				0x8DE, 0x8DC, 0x8DA, 0x8D8, 0x8D6, 0x8D4, 0x8D2, 0x8D0, 
				0x8CE, 0x8CC, 0x8CA, 0x8C8, 0x8C6, 0x8C4, 0x8C2, 0x8C0, 
				0x8BE, 0x8BC, 0x8BA, 0x8B8, 0x8B6, 0x8B4, 0x8B2, 0x8B0, 
				0x8AE, 0x8AC, 0x8AA, 0x8A8, 0x8A6, 0x8A4, 0x8A2, 0x8A0, 
				0x89E, 0x89C, 0x89A, 0x898, 0x896, 0x894, 0x892, 0x890, 
				0x88E, 0x88C, 0x88A, 0x888, 0x886, 0x884, 0x882, 0x880, 
				0x87E, 0x87C, 0x87A, 0x878, 0x876, 0x874, 0x872, 0x870, 
				0x86E, 0x86C, 0x86A, 0x868, 0x866, 0x864, 0x862, 0x860, 
				0x85E, 0x85C, 0x85A, 0x858, 0x856, 0x854, 0x852, 0x850, 
				0x84E, 0x84C, 0x84A, 0x848, 0x846, 0x844, 0x842, 0x840, 
				0x83E, 0x83C, 0x83A, 0x838, 0x836, 0x834, 0x832, 0x830, 
				0x82E, 0x82C, 0x82A, 0x828, 0x826, 0x824, 0x822, 0x820, 
				0x81E, 0x81C, 0x81A, 0x818, 0x816, 0x814, 0x812, 0x810, 
				0x80E, 0x80C, 0x80A, 0x808, 0x806, 0x804, 0x802, 0x800, 
				0x7FE, 0x7FC, 0x7FA, 0x7F8, 0x7F6, 0x7F4, 0x7F2, 0x7F0, 
				0x7EE, 0x7EC, 0x7EA, 0x7E8, 0x7E6, 0x7E4, 0x7E2, 0x7E0, 
				0x7DE, 0x7DC, 0x7DA, 0x7D8, 0x7D6, 0x7D4, 0x7D2, 0x7D0, 
				0x7CE, 0x7CC, 0x7CA, 0x7C8, 0x7C6, 0x7C4, 0x7C2, 0x7C0, 
				0x7BE, 0x7BC, 0x7BA, 0x7B8, 0x7B6, 0x7B4, 0x7B2, 0x7B0, 
				0x7AE, 0x7AC, 0x7AA, 0x7A8, 0x7A6, 0x7A4, 0x7A2, 0x7A0, 
				0x79E, 0x79C, 0x79A, 0x798, 0x796, 0x794, 0x792, 0x790, 
				0x78E, 0x78C, 0x78A, 0x788, 0x786, 0x784, 0x782, 0x780, 
				0x77E, 0x77C, 0x77A, 0x778, 0x776, 0x774, 0x772, 0x770, 
				0x76E, 0x76C, 0x76A, 0x768, 0x766, 0x764, 0x762, 0x760, 
				0x75E, 0x75C, 0x75A, 0x758, 0x756, 0x754, 0x752, 0x750, 
				0x74E, 0x74C, 0x74A, 0x748, 0x746, 0x744, 0x742, 0x740, 
				0x73E, 0x73C, 0x73A, 0x738, 0x736, 0x734, 0x732, 0x730, 
				0x72E, 0x72C, 0x72A, 0x728, 0x726, 0x724, 0x722, 0x720, 
				0x71E, 0x71C, 0x71A, 0x718, 0x716, 0x714, 0x712, 0x710, 
				0x70E, 0x70C, 0x70A, 0x708, 0x706, 0x704, 0x702, 0x700, 
				0x6FE, 0x6FC, 0x6FA, 0x6F8, 0x6F6, 0x6F4, 0x6F2, 0x6F0, 
				0x6EE, 0x6EC, 0x6EA, 0x6E8, 0x6E6, 0x6E4, 0x6E2, 0x6E0, 
				0x6DE, 0x6DC, 0x6DA, 0x6D8, 0x6D6, 0x6D4, 0x6D2, 0x6D0, 
				0x6CE, 0x6CC, 0x6CA, 0x6C8, 0x6C6, 0x6C4, 0x6C2, 0x6C0, 
				0x6BE, 0x6BC, 0x6BA, 0x6B8, 0x6B6, 0x6B4, 0x6B2, 0x6B0, 
				0x6AE, 0x6AC, 0x6AA, 0x6A8, 0x6A6, 0x6A4, 0x6A2, 0x6A0, 
				0x69E, 0x69C, 0x69A, 0x698, 0x696, 0x694, 0x692, 0x690, 
				0x68E, 0x68C, 0x68A, 0x688, 0x686, 0x684, 0x682, 0x680, 
				0x67E, 0x67C, 0x67A, 0x678, 0x676, 0x674, 0x672, 0x670, 
				0x66E, 0x66C, 0x66A, 0x668, 0x666, 0x664, 0x662, 0x660, 
				0x65E, 0x65C, 0x65A, 0x658, 0x656, 0x654, 0x652, 0x650, 
				0x64E, 0x64C, 0x64A, 0x648, 0x646, 0x644, 0x642, 0x640, 
				0x63E, 0x63C, 0x63A, 0x638, 0x636, 0x634, 0x632, 0x630, 
				0x62E, 0x62C, 0x62A, 0x628, 0x626, 0x624, 0x622, 0x620, 
				0x61E, 0x61C, 0x61A, 0x618, 0x616, 0x614, 0x612, 0x610, 
				0x60E, 0x60C, 0x60A, 0x608, 0x606, 0x604, 0x602, 0x600, 
				0x5FE, 0x5FC, 0x5FA, 0x5F8, 0x5F6, 0x5F4, 0x5F2, 0x5F0, 
				0x5EE, 0x5EC, 0x5EA, 0x5E8, 0x5E6, 0x5E4, 0x5E2, 0x5E0, 
				0x5DE, 0x5DC, 0x5DA, 0x5D8, 0x5D6, 0x5D4, 0x5D2, 0x5D0, 
				0x5CE, 0x5CC, 0x5CA, 0x5C8, 0x5C6, 0x5C4, 0x5C2, 0x5C0, 
				0x5BE, 0x5BC, 0x5BA, 0x5B8, 0x5B6, 0x5B4, 0x5B2, 0x5B0, 
				0x5AE, 0x5AC, 0x5AA, 0x5A8, 0x5A6, 0x5A4, 0x5A2, 0x5A0, 
				0x59E, 0x59C, 0x59A, 0x598, 0x596, 0x594, 0x592, 0x590, 
				0x58E, 0x58C, 0x58A, 0x588, 0x586, 0x584, 0x582, 0x580, 
				0x57E, 0x57C, 0x57A, 0x578, 0x576, 0x574, 0x572, 0x570, 
				0x56E, 0x56C, 0x56A, 0x568, 0x566, 0x564, 0x562, 0x560, 
				0x55E, 0x55C, 0x55A, 0x558, 0x556, 0x554, 0x552, 0x550, 
				0x54E, 0x54C, 0x54A, 0x548, 0x546, 0x544, 0x542, 0x540, 
				0x53E, 0x53C, 0x53A, 0x538, 0x536, 0x534, 0x532, 0x530, 
				0x52E, 0x52C, 0x52A, 0x528, 0x526, 0x524, 0x522, 0x520, 
				0x51E, 0x51C, 0x51A, 0x518, 0x516, 0x514, 0x512, 0x510, 
				0x50E, 0x50C, 0x50A, 0x508, 0x506, 0x504, 0x502, 0x500, 
				0x4FE, 0x4FC, 0x4FA, 0x4F8, 0x4F6, 0x4F4, 0x4F2, 0x4F0, 
				0x4EE, 0x4EC, 0x4EA, 0x4E8, 0x4E6, 0x4E4, 0x4E2, 0x4E0, 
				0x4DE, 0x4DC, 0x4DA, 0x4D8, 0x4D6, 0x4D4, 0x4D2, 0x4D0, 
				0x4CE, 0x4CC, 0x4CA, 0x4C8, 0x4C6, 0x4C4, 0x4C2, 0x4C0, 
				0x4BE, 0x4BC, 0x4BA, 0x4B8, 0x4B6, 0x4B4, 0x4B2, 0x4B0, 
				0x4AE, 0x4AC, 0x4AA, 0x4A8, 0x4A6, 0x4A4, 0x4A2, 0x4A0, 
				0x49E, 0x49C, 0x49A, 0x498, 0x496, 0x494, 0x492, 0x490, 
				0x48E, 0x48C, 0x48A, 0x488, 0x486, 0x484, 0x482, 0x480, 
				0x47E, 0x47C, 0x47A, 0x478, 0x476, 0x474, 0x472, 0x470, 
				0x46E, 0x46C, 0x46A, 0x468, 0x466, 0x464, 0x462, 0x460, 
				0x45E, 0x45C, 0x45A, 0x458, 0x456, 0x454, 0x452, 0x450, 
				0x44E, 0x44C, 0x44A, 0x448, 0x446, 0x444, 0x442, 0x440, 
				0x43E, 0x43C, 0x43A, 0x438, 0x436, 0x434, 0x432, 0x430, 
				0x42E, 0x42C, 0x42A, 0x428, 0x426, 0x424, 0x422, 0x420, 
				0x41E, 0x41C, 0x41A, 0x418, 0x416, 0x414, 0x412, 0x410, 
				0x40E, 0x40C, 0x40A, 0x408, 0x406, 0x404, 0x402, 0x400, 
				0x3FE, 0x3FC, 0x3FA, 0x3F8, 0x3F6, 0x3F4, 0x3F2, 0x3F0, 
				0x3EE, 0x3EC, 0x3EA, 0x3E8, 0x3E6, 0x3E4, 0x3E2, 0x3E0, 
				0x3DE, 0x3DC, 0x3DA, 0x3D8, 0x3D6, 0x3D4, 0x3D2, 0x3D0, 
				0x3CE, 0x3CC, 0x3CA, 0x3C8, 0x3C6, 0x3C4, 0x3C2, 0x3C0, 
				0x3BE, 0x3BC, 0x3BA, 0x3B8, 0x3B6, 0x3B4, 0x3B2, 0x3B0, 
				0x3AE, 0x3AC, 0x3AA, 0x3A8, 0x3A6, 0x3A4, 0x3A2, 0x3A0, 
				0x39E, 0x39C, 0x39A, 0x398, 0x396, 0x394, 0x392, 0x390, 
				0x38E, 0x38C, 0x38A, 0x388, 0x386, 0x384, 0x382, 0x380, 
				0x37E, 0x37C, 0x37A, 0x378, 0x376, 0x374, 0x372, 0x370, 
				0x36E, 0x36C, 0x36A, 0x368, 0x366, 0x364, 0x362, 0x360, 
				0x35E, 0x35C, 0x35A, 0x358, 0x356, 0x354, 0x352, 0x350, 
				0x34E, 0x34C, 0x34A, 0x348, 0x346, 0x344, 0x342, 0x340, 
				0x33E, 0x33C, 0x33A, 0x338, 0x336, 0x334, 0x332, 0x330, 
				0x32E, 0x32C, 0x32A, 0x328, 0x326, 0x324, 0x322, 0x320, 
				0x31E, 0x31C, 0x31A, 0x318, 0x316, 0x314, 0x312, 0x310, 
				0x30E, 0x30C, 0x30A, 0x308, 0x306, 0x304, 0x302, 0x300, 
				0x2FE, 0x2FC, 0x2FA, 0x2F8, 0x2F6, 0x2F4, 0x2F2, 0x2F0, 
				0x2EE, 0x2EC, 0x2EA, 0x2E8, 0x2E6, 0x2E4, 0x2E2, 0x2E0, 
				0x2DE, 0x2DC, 0x2DA, 0x2D8, 0x2D6, 0x2D4, 0x2D2, 0x2D0, 
				0x2CE, 0x2CC, 0x2CA, 0x2C8, 0x2C6, 0x2C4, 0x2C2, 0x2C0, 
				0x2BE, 0x2BC, 0x2BA, 0x2B8, 0x2B6, 0x2B4, 0x2B2, 0x2B0, 
				0x2AE, 0x2AC, 0x2AA, 0x2A8, 0x2A6, 0x2A4, 0x2A2, 0x2A0, 
				0x29E, 0x29C, 0x29A, 0x298, 0x296, 0x294, 0x292, 0x290, 
				0x28E, 0x28C, 0x28A, 0x288, 0x286, 0x284, 0x282, 0x280, 
				0x27E, 0x27C, 0x27A, 0x278, 0x276, 0x274, 0x272, 0x270, 
				0x26E, 0x26C, 0x26A, 0x268, 0x266, 0x264, 0x262, 0x260, 
				0x25E, 0x25C, 0x25A, 0x258, 0x256, 0x254, 0x252, 0x250, 
				0x24E, 0x24C, 0x24A, 0x248, 0x246, 0x244, 0x242, 0x240, 
				0x23E, 0x23C, 0x23A, 0x238, 0x236, 0x234, 0x232, 0x230, 
				0x22E, 0x22C, 0x22A, 0x228, 0x226, 0x224, 0x222, 0x220, 
				0x21E, 0x21C, 0x21A, 0x218, 0x216, 0x214, 0x212, 0x210, 
				0x20E, 0x20C, 0x20A, 0x208, 0x206, 0x204, 0x202, 0x200, 
				0x1FE, 0x1FC, 0x1FA, 0x1F8, 0x1F6, 0x1F4, 0x1F2, 0x1F0, 
				0x1EE, 0x1EC, 0x1EA, 0x1E8, 0x1E6, 0x1E4, 0x1E2, 0x1E0, 
				0x1DE, 0x1DC, 0x1DA, 0x1D8, 0x1D6, 0x1D4, 0x1D2, 0x1D0, 
				0x1CE, 0x1CC, 0x1CA, 0x1C8, 0x1C6, 0x1C4, 0x1C2, 0x1C0, 
				0x1BE, 0x1BC, 0x1BA, 0x1B8, 0x1B6, 0x1B4, 0x1B2, 0x1B0, 
				0x1AE, 0x1AC, 0x1AA, 0x1A8, 0x1A6, 0x1A4, 0x1A2, 0x1A0, 
				0x19E, 0x19C, 0x19A, 0x198, 0x196, 0x194, 0x192, 0x190, 
				0x18E, 0x18C, 0x18A, 0x188, 0x186, 0x184, 0x182, 0x180, 
				0x17E, 0x17C, 0x17A, 0x178, 0x176, 0x174, 0x172, 0x170, 
				0x16E, 0x16C, 0x16A, 0x168, 0x166, 0x164, 0x162, 0x160, 
				0x15E, 0x15C, 0x15A, 0x158, 0x156, 0x154, 0x152, 0x150, 
				0x14E, 0x14C, 0x14A, 0x148, 0x146, 0x144, 0x142, 0x140, 
				0x13E, 0x13C, 0x13A, 0x138, 0x136, 0x134, 0x132, 0x130, 
				0x12E, 0x12C, 0x12A, 0x128, 0x126, 0x124, 0x122, 0x120, 
				0x11E, 0x11C, 0x11A, 0x118, 0x116, 0x114, 0x112, 0x110, 
				0x10E, 0x10C, 0x10A, 0x108, 0x106, 0x104, 0x102, 0x100, 
				0x0FE, 0x0FC, 0x0FA, 0x0F8, 0x0F6, 0x0F4, 0x0F2, 0x0F0, 
				0x0EE, 0x0EC, 0x0EA, 0x0E8, 0x0E6, 0x0E4, 0x0E2, 0x0E0, 
				0x0DE, 0x0DC, 0x0DA, 0x0D8, 0x0D6, 0x0D4, 0x0D2, 0x0D0, 
				0x0CE, 0x0CC, 0x0CA, 0x0C8, 0x0C6, 0x0C4, 0x0C2, 0x0C0, 
				0x0BE, 0x0BC, 0x0BA, 0x0B8, 0x0B6, 0x0B4, 0x0B2, 0x0B0, 
				0x0AE, 0x0AC, 0x0AA, 0x0A8, 0x0A6, 0x0A4, 0x0A2, 0x0A0, 
				0x09E, 0x09C, 0x09A, 0x098, 0x096, 0x094, 0x092, 0x090, 
				0x08E, 0x08C, 0x08A, 0x088, 0x086, 0x084, 0x082, 0x080, 
				0x07E, 0x07C, 0x07A, 0x078, 0x076, 0x074, 0x072, 0x070, 
				0x06E, 0x06C, 0x06A, 0x068, 0x066, 0x064, 0x062, 0x060, 
				0x05E, 0x05C, 0x05A, 0x058, 0x056, 0x054, 0x052, 0x050, 
				0x04E, 0x04C, 0x04A, 0x048, 0x046, 0x044, 0x042, 0x040, 
				0x03E, 0x03C, 0x03A, 0x038, 0x036, 0x034, 0x032, 0x030, 
				0x02E, 0x02C, 0x02A, 0x028, 0x026, 0x024, 0x022, 0x020, 
				0x01E, 0x01C, 0x01A, 0x018, 0x016, 0x014, 0x012, 0x010, 
				0x00E, 0x00C, 0x00A, 0x008, 0x006, 0x004, 0x002, 0x000
			},
			new int[] {
				0x000, 0x001, 0x002, 0x003, 0x004, 0x005, 0x006, 0x007, 
				0x008, 0x009, 0x00A, 0x00B, 0x00C, 0x00D, 0x00E, 0x00F, 
				0x010, 0x011, 0x012, 0x013, 0x014, 0x015, 0x016, 0x017, 
				0x018, 0x019, 0x01A, 0x01B, 0x01C, 0x01D, 0x01E, 0x01F, 
				0x020, 0x021, 0x022, 0x023, 0x024, 0x025, 0x026, 0x027, 
				0x028, 0x029, 0x02A, 0x02B, 0x02C, 0x02D, 0x02E, 0x02F, 
				0x030, 0x031, 0x032, 0x033, 0x034, 0x035, 0x036, 0x037, 
				0x038, 0x039, 0x03A, 0x03B, 0x03C, 0x03D, 0x03E, 0x03F, 
				0x040, 0x041, 0x042, 0x043, 0x044, 0x045, 0x046, 0x047, 
				0x048, 0x049, 0x04A, 0x04B, 0x04C, 0x04D, 0x04E, 0x04F, 
				0x050, 0x051, 0x052, 0x053, 0x054, 0x055, 0x056, 0x057, 
				0x058, 0x059, 0x05A, 0x05B, 0x05C, 0x05D, 0x05E, 0x05F, 
				0x060, 0x061, 0x062, 0x063, 0x064, 0x065, 0x066, 0x067, 
				0x068, 0x069, 0x06A, 0x06B, 0x06C, 0x06D, 0x06E, 0x06F, 
				0x070, 0x071, 0x072, 0x073, 0x074, 0x075, 0x076, 0x077, 
				0x078, 0x079, 0x07A, 0x07B, 0x07C, 0x07D, 0x07E, 0x07F, 
				0x080, 0x081, 0x082, 0x083, 0x084, 0x085, 0x086, 0x087, 
				0x088, 0x089, 0x08A, 0x08B, 0x08C, 0x08D, 0x08E, 0x08F, 
				0x090, 0x091, 0x092, 0x093, 0x094, 0x095, 0x096, 0x097, 
				0x098, 0x099, 0x09A, 0x09B, 0x09C, 0x09D, 0x09E, 0x09F, 
				0x0A0, 0x0A1, 0x0A2, 0x0A3, 0x0A4, 0x0A5, 0x0A6, 0x0A7, 
				0x0A8, 0x0A9, 0x0AA, 0x0AB, 0x0AC, 0x0AD, 0x0AE, 0x0AF, 
				0x0B0, 0x0B1, 0x0B2, 0x0B3, 0x0B4, 0x0B5, 0x0B6, 0x0B7, 
				0x0B8, 0x0B9, 0x0BA, 0x0BB, 0x0BC, 0x0BD, 0x0BE, 0x0BF, 
				0x0C0, 0x0C1, 0x0C2, 0x0C3, 0x0C4, 0x0C5, 0x0C6, 0x0C7, 
				0x0C8, 0x0C9, 0x0CA, 0x0CB, 0x0CC, 0x0CD, 0x0CE, 0x0CF, 
				0x0D0, 0x0D1, 0x0D2, 0x0D3, 0x0D4, 0x0D5, 0x0D6, 0x0D7, 
				0x0D8, 0x0D9, 0x0DA, 0x0DB, 0x0DC, 0x0DD, 0x0DE, 0x0DF, 
				0x0E0, 0x0E1, 0x0E2, 0x0E3, 0x0E4, 0x0E5, 0x0E6, 0x0E7, 
				0x0E8, 0x0E9, 0x0EA, 0x0EB, 0x0EC, 0x0ED, 0x0EE, 0x0EF, 
				0x0F0, 0x0F1, 0x0F2, 0x0F3, 0x0F4, 0x0F5, 0x0F6, 0x0F7, 
				0x0F8, 0x0F9, 0x0FA, 0x0FB, 0x0FC, 0x0FD, 0x0FE, 0x0FF, 
				0x100, 0x101, 0x102, 0x103, 0x104, 0x105, 0x106, 0x107, 
				0x108, 0x109, 0x10A, 0x10B, 0x10C, 0x10D, 0x10E, 0x10F, 
				0x110, 0x111, 0x112, 0x113, 0x114, 0x115, 0x116, 0x117, 
				0x118, 0x119, 0x11A, 0x11B, 0x11C, 0x11D, 0x11E, 0x11F, 
				0x120, 0x121, 0x122, 0x123, 0x124, 0x125, 0x126, 0x127, 
				0x128, 0x129, 0x12A, 0x12B, 0x12C, 0x12D, 0x12E, 0x12F, 
				0x130, 0x131, 0x132, 0x133, 0x134, 0x135, 0x136, 0x137, 
				0x138, 0x139, 0x13A, 0x13B, 0x13C, 0x13D, 0x13E, 0x13F, 
				0x140, 0x141, 0x142, 0x143, 0x144, 0x145, 0x146, 0x147, 
				0x148, 0x149, 0x14A, 0x14B, 0x14C, 0x14D, 0x14E, 0x14F, 
				0x150, 0x151, 0x152, 0x153, 0x154, 0x155, 0x156, 0x157, 
				0x158, 0x159, 0x15A, 0x15B, 0x15C, 0x15D, 0x15E, 0x15F, 
				0x160, 0x161, 0x162, 0x163, 0x164, 0x165, 0x166, 0x167, 
				0x168, 0x169, 0x16A, 0x16B, 0x16C, 0x16D, 0x16E, 0x16F, 
				0x170, 0x171, 0x172, 0x173, 0x174, 0x175, 0x176, 0x177, 
				0x178, 0x179, 0x17A, 0x17B, 0x17C, 0x17D, 0x17E, 0x17F, 
				0x180, 0x181, 0x182, 0x183, 0x184, 0x185, 0x186, 0x187, 
				0x188, 0x189, 0x18A, 0x18B, 0x18C, 0x18D, 0x18E, 0x18F, 
				0x190, 0x191, 0x192, 0x193, 0x194, 0x195, 0x196, 0x197, 
				0x198, 0x199, 0x19A, 0x19B, 0x19C, 0x19D, 0x19E, 0x19F, 
				0x1A0, 0x1A1, 0x1A2, 0x1A3, 0x1A4, 0x1A5, 0x1A6, 0x1A7, 
				0x1A8, 0x1A9, 0x1AA, 0x1AB, 0x1AC, 0x1AD, 0x1AE, 0x1AF, 
				0x1B0, 0x1B1, 0x1B2, 0x1B3, 0x1B4, 0x1B5, 0x1B6, 0x1B7, 
				0x1B8, 0x1B9, 0x1BA, 0x1BB, 0x1BC, 0x1BD, 0x1BE, 0x1BF, 
				0x1C0, 0x1C1, 0x1C2, 0x1C3, 0x1C4, 0x1C5, 0x1C6, 0x1C7, 
				0x1C8, 0x1C9, 0x1CA, 0x1CB, 0x1CC, 0x1CD, 0x1CE, 0x1CF, 
				0x1D0, 0x1D1, 0x1D2, 0x1D3, 0x1D4, 0x1D5, 0x1D6, 0x1D7, 
				0x1D8, 0x1D9, 0x1DA, 0x1DB, 0x1DC, 0x1DD, 0x1DE, 0x1DF, 
				0x1E0, 0x1E1, 0x1E2, 0x1E3, 0x1E4, 0x1E5, 0x1E6, 0x1E7, 
				0x1E8, 0x1E9, 0x1EA, 0x1EB, 0x1EC, 0x1ED, 0x1EE, 0x1EF, 
				0x1F0, 0x1F1, 0x1F2, 0x1F3, 0x1F4, 0x1F5, 0x1F6, 0x1F7, 
				0x1F8, 0x1F9, 0x1FA, 0x1FB, 0x1FC, 0x1FD, 0x1FE, 0x1FF, 
				0x200, 0x201, 0x202, 0x203, 0x204, 0x205, 0x206, 0x207, 
				0x208, 0x209, 0x20A, 0x20B, 0x20C, 0x20D, 0x20E, 0x20F, 
				0x210, 0x211, 0x212, 0x213, 0x214, 0x215, 0x216, 0x217, 
				0x218, 0x219, 0x21A, 0x21B, 0x21C, 0x21D, 0x21E, 0x21F, 
				0x220, 0x221, 0x222, 0x223, 0x224, 0x225, 0x226, 0x227, 
				0x228, 0x229, 0x22A, 0x22B, 0x22C, 0x22D, 0x22E, 0x22F, 
				0x230, 0x231, 0x232, 0x233, 0x234, 0x235, 0x236, 0x237, 
				0x238, 0x239, 0x23A, 0x23B, 0x23C, 0x23D, 0x23E, 0x23F, 
				0x240, 0x241, 0x242, 0x243, 0x244, 0x245, 0x246, 0x247, 
				0x248, 0x249, 0x24A, 0x24B, 0x24C, 0x24D, 0x24E, 0x24F, 
				0x250, 0x251, 0x252, 0x253, 0x254, 0x255, 0x256, 0x257, 
				0x258, 0x259, 0x25A, 0x25B, 0x25C, 0x25D, 0x25E, 0x25F, 
				0x260, 0x261, 0x262, 0x263, 0x264, 0x265, 0x266, 0x267, 
				0x268, 0x269, 0x26A, 0x26B, 0x26C, 0x26D, 0x26E, 0x26F, 
				0x270, 0x271, 0x272, 0x273, 0x274, 0x275, 0x276, 0x277, 
				0x278, 0x279, 0x27A, 0x27B, 0x27C, 0x27D, 0x27E, 0x27F, 
				0x280, 0x281, 0x282, 0x283, 0x284, 0x285, 0x286, 0x287, 
				0x288, 0x289, 0x28A, 0x28B, 0x28C, 0x28D, 0x28E, 0x28F, 
				0x290, 0x291, 0x292, 0x293, 0x294, 0x295, 0x296, 0x297, 
				0x298, 0x299, 0x29A, 0x29B, 0x29C, 0x29D, 0x29E, 0x29F, 
				0x2A0, 0x2A1, 0x2A2, 0x2A3, 0x2A4, 0x2A5, 0x2A6, 0x2A7, 
				0x2A8, 0x2A9, 0x2AA, 0x2AB, 0x2AC, 0x2AD, 0x2AE, 0x2AF, 
				0x2B0, 0x2B1, 0x2B2, 0x2B3, 0x2B4, 0x2B5, 0x2B6, 0x2B7, 
				0x2B8, 0x2B9, 0x2BA, 0x2BB, 0x2BC, 0x2BD, 0x2BE, 0x2BF, 
				0x2C0, 0x2C1, 0x2C2, 0x2C3, 0x2C4, 0x2C5, 0x2C6, 0x2C7, 
				0x2C8, 0x2C9, 0x2CA, 0x2CB, 0x2CC, 0x2CD, 0x2CE, 0x2CF, 
				0x2D0, 0x2D1, 0x2D2, 0x2D3, 0x2D4, 0x2D5, 0x2D6, 0x2D7, 
				0x2D8, 0x2D9, 0x2DA, 0x2DB, 0x2DC, 0x2DD, 0x2DE, 0x2DF, 
				0x2E0, 0x2E1, 0x2E2, 0x2E3, 0x2E4, 0x2E5, 0x2E6, 0x2E7, 
				0x2E8, 0x2E9, 0x2EA, 0x2EB, 0x2EC, 0x2ED, 0x2EE, 0x2EF, 
				0x2F0, 0x2F1, 0x2F2, 0x2F3, 0x2F4, 0x2F5, 0x2F6, 0x2F7, 
				0x2F8, 0x2F9, 0x2FA, 0x2FB, 0x2FC, 0x2FD, 0x2FE, 0x2FF, 
				0x300, 0x301, 0x302, 0x303, 0x304, 0x305, 0x306, 0x307, 
				0x308, 0x309, 0x30A, 0x30B, 0x30C, 0x30D, 0x30E, 0x30F, 
				0x310, 0x311, 0x312, 0x313, 0x314, 0x315, 0x316, 0x317, 
				0x318, 0x319, 0x31A, 0x31B, 0x31C, 0x31D, 0x31E, 0x31F, 
				0x320, 0x321, 0x322, 0x323, 0x324, 0x325, 0x326, 0x327, 
				0x328, 0x329, 0x32A, 0x32B, 0x32C, 0x32D, 0x32E, 0x32F, 
				0x330, 0x331, 0x332, 0x333, 0x334, 0x335, 0x336, 0x337, 
				0x338, 0x339, 0x33A, 0x33B, 0x33C, 0x33D, 0x33E, 0x33F, 
				0x340, 0x341, 0x342, 0x343, 0x344, 0x345, 0x346, 0x347, 
				0x348, 0x349, 0x34A, 0x34B, 0x34C, 0x34D, 0x34E, 0x34F, 
				0x350, 0x351, 0x352, 0x353, 0x354, 0x355, 0x356, 0x357, 
				0x358, 0x359, 0x35A, 0x35B, 0x35C, 0x35D, 0x35E, 0x35F, 
				0x360, 0x361, 0x362, 0x363, 0x364, 0x365, 0x366, 0x367, 
				0x368, 0x369, 0x36A, 0x36B, 0x36C, 0x36D, 0x36E, 0x36F, 
				0x370, 0x371, 0x372, 0x373, 0x374, 0x375, 0x376, 0x377, 
				0x378, 0x379, 0x37A, 0x37B, 0x37C, 0x37D, 0x37E, 0x37F, 
				0x380, 0x381, 0x382, 0x383, 0x384, 0x385, 0x386, 0x387, 
				0x388, 0x389, 0x38A, 0x38B, 0x38C, 0x38D, 0x38E, 0x38F, 
				0x390, 0x391, 0x392, 0x393, 0x394, 0x395, 0x396, 0x397, 
				0x398, 0x399, 0x39A, 0x39B, 0x39C, 0x39D, 0x39E, 0x39F, 
				0x3A0, 0x3A1, 0x3A2, 0x3A3, 0x3A4, 0x3A5, 0x3A6, 0x3A7, 
				0x3A8, 0x3A9, 0x3AA, 0x3AB, 0x3AC, 0x3AD, 0x3AE, 0x3AF, 
				0x3B0, 0x3B1, 0x3B2, 0x3B3, 0x3B4, 0x3B5, 0x3B6, 0x3B7, 
				0x3B8, 0x3B9, 0x3BA, 0x3BB, 0x3BC, 0x3BD, 0x3BE, 0x3BF, 
				0x3C0, 0x3C1, 0x3C2, 0x3C3, 0x3C4, 0x3C5, 0x3C6, 0x3C7, 
				0x3C8, 0x3C9, 0x3CA, 0x3CB, 0x3CC, 0x3CD, 0x3CE, 0x3CF, 
				0x3D0, 0x3D1, 0x3D2, 0x3D3, 0x3D4, 0x3D5, 0x3D6, 0x3D7, 
				0x3D8, 0x3D9, 0x3DA, 0x3DB, 0x3DC, 0x3DD, 0x3DE, 0x3DF, 
				0x3E0, 0x3E1, 0x3E2, 0x3E3, 0x3E4, 0x3E5, 0x3E6, 0x3E7, 
				0x3E8, 0x3E9, 0x3EA, 0x3EB, 0x3EC, 0x3ED, 0x3EE, 0x3EF, 
				0x3F0, 0x3F1, 0x3F2, 0x3F3, 0x3F4, 0x3F5, 0x3F6, 0x3F7, 
				0x3F8, 0x3F9, 0x3FA, 0x3FB, 0x3FC, 0x3FD, 0x3FE, 0x3FF, 
				0x400, 0x401, 0x402, 0x403, 0x404, 0x405, 0x406, 0x407, 
				0x408, 0x409, 0x40A, 0x40B, 0x40C, 0x40D, 0x40E, 0x40F, 
				0x410, 0x411, 0x412, 0x413, 0x414, 0x415, 0x416, 0x417, 
				0x418, 0x419, 0x41A, 0x41B, 0x41C, 0x41D, 0x41E, 0x41F, 
				0x420, 0x421, 0x422, 0x423, 0x424, 0x425, 0x426, 0x427, 
				0x428, 0x429, 0x42A, 0x42B, 0x42C, 0x42D, 0x42E, 0x42F, 
				0x430, 0x431, 0x432, 0x433, 0x434, 0x435, 0x436, 0x437, 
				0x438, 0x439, 0x43A, 0x43B, 0x43C, 0x43D, 0x43E, 0x43F, 
				0x440, 0x441, 0x442, 0x443, 0x444, 0x445, 0x446, 0x447, 
				0x448, 0x449, 0x44A, 0x44B, 0x44C, 0x44D, 0x44E, 0x44F, 
				0x450, 0x451, 0x452, 0x453, 0x454, 0x455, 0x456, 0x457, 
				0x458, 0x459, 0x45A, 0x45B, 0x45C, 0x45D, 0x45E, 0x45F, 
				0x460, 0x461, 0x462, 0x463, 0x464, 0x465, 0x466, 0x467, 
				0x468, 0x469, 0x46A, 0x46B, 0x46C, 0x46D, 0x46E, 0x46F, 
				0x470, 0x471, 0x472, 0x473, 0x474, 0x475, 0x476, 0x477, 
				0x478, 0x479, 0x47A, 0x47B, 0x47C, 0x47D, 0x47E, 0x47F, 
				0x480, 0x481, 0x482, 0x483, 0x484, 0x485, 0x486, 0x487, 
				0x488, 0x489, 0x48A, 0x48B, 0x48C, 0x48D, 0x48E, 0x48F, 
				0x490, 0x491, 0x492, 0x493, 0x494, 0x495, 0x496, 0x497, 
				0x498, 0x499, 0x49A, 0x49B, 0x49C, 0x49D, 0x49E, 0x49F, 
				0x4A0, 0x4A1, 0x4A2, 0x4A3, 0x4A4, 0x4A5, 0x4A6, 0x4A7, 
				0x4A8, 0x4A9, 0x4AA, 0x4AB, 0x4AC, 0x4AD, 0x4AE, 0x4AF, 
				0x4B0, 0x4B1, 0x4B2, 0x4B3, 0x4B4, 0x4B5, 0x4B6, 0x4B7, 
				0x4B8, 0x4B9, 0x4BA, 0x4BB, 0x4BC, 0x4BD, 0x4BE, 0x4BF, 
				0x4C0, 0x4C1, 0x4C2, 0x4C3, 0x4C4, 0x4C5, 0x4C6, 0x4C7, 
				0x4C8, 0x4C9, 0x4CA, 0x4CB, 0x4CC, 0x4CD, 0x4CE, 0x4CF, 
				0x4D0, 0x4D1, 0x4D2, 0x4D3, 0x4D4, 0x4D5, 0x4D6, 0x4D7, 
				0x4D8, 0x4D9, 0x4DA, 0x4DB, 0x4DC, 0x4DD, 0x4DE, 0x4DF, 
				0x4E0, 0x4E1, 0x4E2, 0x4E3, 0x4E4, 0x4E5, 0x4E6, 0x4E7, 
				0x4E8, 0x4E9, 0x4EA, 0x4EB, 0x4EC, 0x4ED, 0x4EE, 0x4EF, 
				0x4F0, 0x4F1, 0x4F2, 0x4F3, 0x4F4, 0x4F5, 0x4F6, 0x4F7, 
				0x4F8, 0x4F9, 0x4FA, 0x4FB, 0x4FC, 0x4FD, 0x4FE, 0x4FF, 
				0x500, 0x501, 0x502, 0x503, 0x504, 0x505, 0x506, 0x507, 
				0x508, 0x509, 0x50A, 0x50B, 0x50C, 0x50D, 0x50E, 0x50F, 
				0x510, 0x511, 0x512, 0x513, 0x514, 0x515, 0x516, 0x517, 
				0x518, 0x519, 0x51A, 0x51B, 0x51C, 0x51D, 0x51E, 0x51F, 
				0x520, 0x521, 0x522, 0x523, 0x524, 0x525, 0x526, 0x527, 
				0x528, 0x529, 0x52A, 0x52B, 0x52C, 0x52D, 0x52E, 0x52F, 
				0x530, 0x531, 0x532, 0x533, 0x534, 0x535, 0x536, 0x537, 
				0x538, 0x539, 0x53A, 0x53B, 0x53C, 0x53D, 0x53E, 0x53F, 
				0x540, 0x541, 0x542, 0x543, 0x544, 0x545, 0x546, 0x547, 
				0x548, 0x549, 0x54A, 0x54B, 0x54C, 0x54D, 0x54E, 0x54F, 
				0x550, 0x551, 0x552, 0x553, 0x554, 0x555, 0x556, 0x557, 
				0x558, 0x559, 0x55A, 0x55B, 0x55C, 0x55D, 0x55E, 0x55F, 
				0x560, 0x561, 0x562, 0x563, 0x564, 0x565, 0x566, 0x567, 
				0x568, 0x569, 0x56A, 0x56B, 0x56C, 0x56D, 0x56E, 0x56F, 
				0x570, 0x571, 0x572, 0x573, 0x574, 0x575, 0x576, 0x577, 
				0x578, 0x579, 0x57A, 0x57B, 0x57C, 0x57D, 0x57E, 0x57F, 
				0x580, 0x581, 0x582, 0x583, 0x584, 0x585, 0x586, 0x587, 
				0x588, 0x589, 0x58A, 0x58B, 0x58C, 0x58D, 0x58E, 0x58F, 
				0x590, 0x591, 0x592, 0x593, 0x594, 0x595, 0x596, 0x597, 
				0x598, 0x599, 0x59A, 0x59B, 0x59C, 0x59D, 0x59E, 0x59F, 
				0x5A0, 0x5A1, 0x5A2, 0x5A3, 0x5A4, 0x5A5, 0x5A6, 0x5A7, 
				0x5A8, 0x5A9, 0x5AA, 0x5AB, 0x5AC, 0x5AD, 0x5AE, 0x5AF, 
				0x5B0, 0x5B1, 0x5B2, 0x5B3, 0x5B4, 0x5B5, 0x5B6, 0x5B7, 
				0x5B8, 0x5B9, 0x5BA, 0x5BB, 0x5BC, 0x5BD, 0x5BE, 0x5BF, 
				0x5C0, 0x5C1, 0x5C2, 0x5C3, 0x5C4, 0x5C5, 0x5C6, 0x5C7, 
				0x5C8, 0x5C9, 0x5CA, 0x5CB, 0x5CC, 0x5CD, 0x5CE, 0x5CF, 
				0x5D0, 0x5D1, 0x5D2, 0x5D3, 0x5D4, 0x5D5, 0x5D6, 0x5D7, 
				0x5D8, 0x5D9, 0x5DA, 0x5DB, 0x5DC, 0x5DD, 0x5DE, 0x5DF, 
				0x5E0, 0x5E1, 0x5E2, 0x5E3, 0x5E4, 0x5E5, 0x5E6, 0x5E7, 
				0x5E8, 0x5E9, 0x5EA, 0x5EB, 0x5EC, 0x5ED, 0x5EE, 0x5EF, 
				0x5F0, 0x5F1, 0x5F2, 0x5F3, 0x5F4, 0x5F5, 0x5F6, 0x5F7, 
				0x5F8, 0x5F9, 0x5FA, 0x5FB, 0x5FC, 0x5FD, 0x5FE, 0x5FF, 
				0x600, 0x601, 0x602, 0x603, 0x604, 0x605, 0x606, 0x607, 
				0x608, 0x609, 0x60A, 0x60B, 0x60C, 0x60D, 0x60E, 0x60F, 
				0x610, 0x611, 0x612, 0x613, 0x614, 0x615, 0x616, 0x617, 
				0x618, 0x619, 0x61A, 0x61B, 0x61C, 0x61D, 0x61E, 0x61F, 
				0x620, 0x621, 0x622, 0x623, 0x624, 0x625, 0x626, 0x627, 
				0x628, 0x629, 0x62A, 0x62B, 0x62C, 0x62D, 0x62E, 0x62F, 
				0x630, 0x631, 0x632, 0x633, 0x634, 0x635, 0x636, 0x637, 
				0x638, 0x639, 0x63A, 0x63B, 0x63C, 0x63D, 0x63E, 0x63F, 
				0x640, 0x641, 0x642, 0x643, 0x644, 0x645, 0x646, 0x647, 
				0x648, 0x649, 0x64A, 0x64B, 0x64C, 0x64D, 0x64E, 0x64F, 
				0x650, 0x651, 0x652, 0x653, 0x654, 0x655, 0x656, 0x657, 
				0x658, 0x659, 0x65A, 0x65B, 0x65C, 0x65D, 0x65E, 0x65F, 
				0x660, 0x661, 0x662, 0x663, 0x664, 0x665, 0x666, 0x667, 
				0x668, 0x669, 0x66A, 0x66B, 0x66C, 0x66D, 0x66E, 0x66F, 
				0x670, 0x671, 0x672, 0x673, 0x674, 0x675, 0x676, 0x677, 
				0x678, 0x679, 0x67A, 0x67B, 0x67C, 0x67D, 0x67E, 0x67F, 
				0x680, 0x681, 0x682, 0x683, 0x684, 0x685, 0x686, 0x687, 
				0x688, 0x689, 0x68A, 0x68B, 0x68C, 0x68D, 0x68E, 0x68F, 
				0x690, 0x691, 0x692, 0x693, 0x694, 0x695, 0x696, 0x697, 
				0x698, 0x699, 0x69A, 0x69B, 0x69C, 0x69D, 0x69E, 0x69F, 
				0x6A0, 0x6A1, 0x6A2, 0x6A3, 0x6A4, 0x6A5, 0x6A6, 0x6A7, 
				0x6A8, 0x6A9, 0x6AA, 0x6AB, 0x6AC, 0x6AD, 0x6AE, 0x6AF, 
				0x6B0, 0x6B1, 0x6B2, 0x6B3, 0x6B4, 0x6B5, 0x6B6, 0x6B7, 
				0x6B8, 0x6B9, 0x6BA, 0x6BB, 0x6BC, 0x6BD, 0x6BE, 0x6BF, 
				0x6C0, 0x6C1, 0x6C2, 0x6C3, 0x6C4, 0x6C5, 0x6C6, 0x6C7, 
				0x6C8, 0x6C9, 0x6CA, 0x6CB, 0x6CC, 0x6CD, 0x6CE, 0x6CF, 
				0x6D0, 0x6D1, 0x6D2, 0x6D3, 0x6D4, 0x6D5, 0x6D6, 0x6D7, 
				0x6D8, 0x6D9, 0x6DA, 0x6DB, 0x6DC, 0x6DD, 0x6DE, 0x6DF, 
				0x6E0, 0x6E1, 0x6E2, 0x6E3, 0x6E4, 0x6E5, 0x6E6, 0x6E7, 
				0x6E8, 0x6E9, 0x6EA, 0x6EB, 0x6EC, 0x6ED, 0x6EE, 0x6EF, 
				0x6F0, 0x6F1, 0x6F2, 0x6F3, 0x6F4, 0x6F5, 0x6F6, 0x6F7, 
				0x6F8, 0x6F9, 0x6FA, 0x6FB, 0x6FC, 0x6FD, 0x6FE, 0x6FF, 
				0x700, 0x701, 0x702, 0x703, 0x704, 0x705, 0x706, 0x707, 
				0x708, 0x709, 0x70A, 0x70B, 0x70C, 0x70D, 0x70E, 0x70F, 
				0x710, 0x711, 0x712, 0x713, 0x714, 0x715, 0x716, 0x717, 
				0x718, 0x719, 0x71A, 0x71B, 0x71C, 0x71D, 0x71E, 0x71F, 
				0x720, 0x721, 0x722, 0x723, 0x724, 0x725, 0x726, 0x727, 
				0x728, 0x729, 0x72A, 0x72B, 0x72C, 0x72D, 0x72E, 0x72F, 
				0x730, 0x731, 0x732, 0x733, 0x734, 0x735, 0x736, 0x737, 
				0x738, 0x739, 0x73A, 0x73B, 0x73C, 0x73D, 0x73E, 0x73F, 
				0x740, 0x741, 0x742, 0x743, 0x744, 0x745, 0x746, 0x747, 
				0x748, 0x749, 0x74A, 0x74B, 0x74C, 0x74D, 0x74E, 0x74F, 
				0x750, 0x751, 0x752, 0x753, 0x754, 0x755, 0x756, 0x757, 
				0x758, 0x759, 0x75A, 0x75B, 0x75C, 0x75D, 0x75E, 0x75F, 
				0x760, 0x761, 0x762, 0x763, 0x764, 0x765, 0x766, 0x767, 
				0x768, 0x769, 0x76A, 0x76B, 0x76C, 0x76D, 0x76E, 0x76F, 
				0x770, 0x771, 0x772, 0x773, 0x774, 0x775, 0x776, 0x777, 
				0x778, 0x779, 0x77A, 0x77B, 0x77C, 0x77D, 0x77E, 0x77F, 
				0x780, 0x781, 0x782, 0x783, 0x784, 0x785, 0x786, 0x787, 
				0x788, 0x789, 0x78A, 0x78B, 0x78C, 0x78D, 0x78E, 0x78F, 
				0x790, 0x791, 0x792, 0x793, 0x794, 0x795, 0x796, 0x797, 
				0x798, 0x799, 0x79A, 0x79B, 0x79C, 0x79D, 0x79E, 0x79F, 
				0x7A0, 0x7A1, 0x7A2, 0x7A3, 0x7A4, 0x7A5, 0x7A6, 0x7A7, 
				0x7A8, 0x7A9, 0x7AA, 0x7AB, 0x7AC, 0x7AD, 0x7AE, 0x7AF, 
				0x7B0, 0x7B1, 0x7B2, 0x7B3, 0x7B4, 0x7B5, 0x7B6, 0x7B7, 
				0x7B8, 0x7B9, 0x7BA, 0x7BB, 0x7BC, 0x7BD, 0x7BE, 0x7BF, 
				0x7C0, 0x7C1, 0x7C2, 0x7C3, 0x7C4, 0x7C5, 0x7C6, 0x7C7, 
				0x7C8, 0x7C9, 0x7CA, 0x7CB, 0x7CC, 0x7CD, 0x7CE, 0x7CF, 
				0x7D0, 0x7D1, 0x7D2, 0x7D3, 0x7D4, 0x7D5, 0x7D6, 0x7D7, 
				0x7D8, 0x7D9, 0x7DA, 0x7DB, 0x7DC, 0x7DD, 0x7DE, 0x7DF, 
				0x7E0, 0x7E1, 0x7E2, 0x7E3, 0x7E4, 0x7E5, 0x7E6, 0x7E7, 
				0x7E8, 0x7E9, 0x7EA, 0x7EB, 0x7EC, 0x7ED, 0x7EE, 0x7EF, 
				0x7F0, 0x7F1, 0x7F2, 0x7F3, 0x7F4, 0x7F5, 0x7F6, 0x7F7, 
				0x7F8, 0x7F9, 0x7FA, 0x7FB, 0x7FC, 0x7FD, 0x7FE, 0x7FF, 
				0x800, 0x801, 0x802, 0x803, 0x804, 0x805, 0x806, 0x807, 
				0x808, 0x809, 0x80A, 0x80B, 0x80C, 0x80D, 0x80E, 0x80F, 
				0x810, 0x811, 0x812, 0x813, 0x814, 0x815, 0x816, 0x817, 
				0x818, 0x819, 0x81A, 0x81B, 0x81C, 0x81D, 0x81E, 0x81F, 
				0x820, 0x821, 0x822, 0x823, 0x824, 0x825, 0x826, 0x827, 
				0x828, 0x829, 0x82A, 0x82B, 0x82C, 0x82D, 0x82E, 0x82F, 
				0x830, 0x831, 0x832, 0x833, 0x834, 0x835, 0x836, 0x837, 
				0x838, 0x839, 0x83A, 0x83B, 0x83C, 0x83D, 0x83E, 0x83F, 
				0x840, 0x841, 0x842, 0x843, 0x844, 0x845, 0x846, 0x847, 
				0x848, 0x849, 0x84A, 0x84B, 0x84C, 0x84D, 0x84E, 0x84F, 
				0x850, 0x851, 0x852, 0x853, 0x854, 0x855, 0x856, 0x857, 
				0x858, 0x859, 0x85A, 0x85B, 0x85C, 0x85D, 0x85E, 0x85F, 
				0x860, 0x861, 0x862, 0x863, 0x864, 0x865, 0x866, 0x867, 
				0x868, 0x869, 0x86A, 0x86B, 0x86C, 0x86D, 0x86E, 0x86F, 
				0x870, 0x871, 0x872, 0x873, 0x874, 0x875, 0x876, 0x877, 
				0x878, 0x879, 0x87A, 0x87B, 0x87C, 0x87D, 0x87E, 0x87F, 
				0x880, 0x881, 0x882, 0x883, 0x884, 0x885, 0x886, 0x887, 
				0x888, 0x889, 0x88A, 0x88B, 0x88C, 0x88D, 0x88E, 0x88F, 
				0x890, 0x891, 0x892, 0x893, 0x894, 0x895, 0x896, 0x897, 
				0x898, 0x899, 0x89A, 0x89B, 0x89C, 0x89D, 0x89E, 0x89F, 
				0x8A0, 0x8A1, 0x8A2, 0x8A3, 0x8A4, 0x8A5, 0x8A6, 0x8A7, 
				0x8A8, 0x8A9, 0x8AA, 0x8AB, 0x8AC, 0x8AD, 0x8AE, 0x8AF, 
				0x8B0, 0x8B1, 0x8B2, 0x8B3, 0x8B4, 0x8B5, 0x8B6, 0x8B7, 
				0x8B8, 0x8B9, 0x8BA, 0x8BB, 0x8BC, 0x8BD, 0x8BE, 0x8BF, 
				0x8C0, 0x8C1, 0x8C2, 0x8C3, 0x8C4, 0x8C5, 0x8C6, 0x8C7, 
				0x8C8, 0x8C9, 0x8CA, 0x8CB, 0x8CC, 0x8CD, 0x8CE, 0x8CF, 
				0x8D0, 0x8D1, 0x8D2, 0x8D3, 0x8D4, 0x8D5, 0x8D6, 0x8D7, 
				0x8D8, 0x8D9, 0x8DA, 0x8DB, 0x8DC, 0x8DD, 0x8DE, 0x8DF, 
				0x8E0, 0x8E1, 0x8E2, 0x8E3, 0x8E4, 0x8E5, 0x8E6, 0x8E7, 
				0x8E8, 0x8E9, 0x8EA, 0x8EB, 0x8EC, 0x8ED, 0x8EE, 0x8EF, 
				0x8F0, 0x8F1, 0x8F2, 0x8F3, 0x8F4, 0x8F5, 0x8F6, 0x8F7, 
				0x8F8, 0x8F9, 0x8FA, 0x8FB, 0x8FC, 0x8FD, 0x8FE, 0x8FF, 
				0x900, 0x901, 0x902, 0x903, 0x904, 0x905, 0x906, 0x907, 
				0x908, 0x909, 0x90A, 0x90B, 0x90C, 0x90D, 0x90E, 0x90F, 
				0x910, 0x911, 0x912, 0x913, 0x914, 0x915, 0x916, 0x917, 
				0x918, 0x919, 0x91A, 0x91B, 0x91C, 0x91D, 0x91E, 0x91F, 
				0x920, 0x921, 0x922, 0x923, 0x924, 0x925, 0x926, 0x927, 
				0x928, 0x929, 0x92A, 0x92B, 0x92C, 0x92D, 0x92E, 0x92F, 
				0x930, 0x931, 0x932, 0x933, 0x934, 0x935, 0x936, 0x937, 
				0x938, 0x939, 0x93A, 0x93B, 0x93C, 0x93D, 0x93E, 0x93F, 
				0x940, 0x941, 0x942, 0x943, 0x944, 0x945, 0x946, 0x947, 
				0x948, 0x949, 0x94A, 0x94B, 0x94C, 0x94D, 0x94E, 0x94F, 
				0x950, 0x951, 0x952, 0x953, 0x954, 0x955, 0x956, 0x957, 
				0x958, 0x959, 0x95A, 0x95B, 0x95C, 0x95D, 0x95E, 0x95F, 
				0x960, 0x961, 0x962, 0x963, 0x964, 0x965, 0x966, 0x967, 
				0x968, 0x969, 0x96A, 0x96B, 0x96C, 0x96D, 0x96E, 0x96F, 
				0x970, 0x971, 0x972, 0x973, 0x974, 0x975, 0x976, 0x977, 
				0x978, 0x979, 0x97A, 0x97B, 0x97C, 0x97D, 0x97E, 0x97F, 
				0x980, 0x981, 0x982, 0x983, 0x984, 0x985, 0x986, 0x987, 
				0x988, 0x989, 0x98A, 0x98B, 0x98C, 0x98D, 0x98E, 0x98F, 
				0x990, 0x991, 0x992, 0x993, 0x994, 0x995, 0x996, 0x997, 
				0x998, 0x999, 0x99A, 0x99B, 0x99C, 0x99D, 0x99E, 0x99F, 
				0x9A0, 0x9A1, 0x9A2, 0x9A3, 0x9A4, 0x9A5, 0x9A6, 0x9A7, 
				0x9A8, 0x9A9, 0x9AA, 0x9AB, 0x9AC, 0x9AD, 0x9AE, 0x9AF, 
				0x9B0, 0x9B1, 0x9B2, 0x9B3, 0x9B4, 0x9B5, 0x9B6, 0x9B7, 
				0x9B8, 0x9B9, 0x9BA, 0x9BB, 0x9BC, 0x9BD, 0x9BE, 0x9BF, 
				0x9C0, 0x9C1, 0x9C2, 0x9C3, 0x9C4, 0x9C5, 0x9C6, 0x9C7, 
				0x9C8, 0x9C9, 0x9CA, 0x9CB, 0x9CC, 0x9CD, 0x9CE, 0x9CF, 
				0x9D0, 0x9D1, 0x9D2, 0x9D3, 0x9D4, 0x9D5, 0x9D6, 0x9D7, 
				0x9D8, 0x9D9, 0x9DA, 0x9DB, 0x9DC, 0x9DD, 0x9DE, 0x9DF, 
				0x9E0, 0x9E1, 0x9E2, 0x9E3, 0x9E4, 0x9E5, 0x9E6, 0x9E7, 
				0x9E8, 0x9E9, 0x9EA, 0x9EB, 0x9EC, 0x9ED, 0x9EE, 0x9EF, 
				0x9F0, 0x9F1, 0x9F2, 0x9F3, 0x9F4, 0x9F5, 0x9F6, 0x9F7, 
				0x9F8, 0x9F9, 0x9FA, 0x9FB, 0x9FC, 0x9FD, 0x9FE, 0x9FF, 
				0xA00, 0xA01, 0xA02, 0xA03, 0xA04, 0xA05, 0xA06, 0xA07, 
				0xA08, 0xA09, 0xA0A, 0xA0B, 0xA0C, 0xA0D, 0xA0E, 0xA0F, 
				0xA10, 0xA11, 0xA12, 0xA13, 0xA14, 0xA15, 0xA16, 0xA17, 
				0xA18, 0xA19, 0xA1A, 0xA1B, 0xA1C, 0xA1D, 0xA1E, 0xA1F, 
				0xA20, 0xA21, 0xA22, 0xA23, 0xA24, 0xA25, 0xA26, 0xA27, 
				0xA28, 0xA29, 0xA2A, 0xA2B, 0xA2C, 0xA2D, 0xA2E, 0xA2F, 
				0xA30, 0xA31, 0xA32, 0xA33, 0xA34, 0xA35, 0xA36, 0xA37, 
				0xA38, 0xA39, 0xA3A, 0xA3B, 0xA3C, 0xA3D, 0xA3E, 0xA3F, 
				0xA40, 0xA41, 0xA42, 0xA43, 0xA44, 0xA45, 0xA46, 0xA47, 
				0xA48, 0xA49, 0xA4A, 0xA4B, 0xA4C, 0xA4D, 0xA4E, 0xA4F, 
				0xA50, 0xA51, 0xA52, 0xA53, 0xA54, 0xA55, 0xA56, 0xA57, 
				0xA58, 0xA59, 0xA5A, 0xA5B, 0xA5C, 0xA5D, 0xA5E, 0xA5F, 
				0xA60, 0xA61, 0xA62, 0xA63, 0xA64, 0xA65, 0xA66, 0xA67, 
				0xA68, 0xA69, 0xA6A, 0xA6B, 0xA6C, 0xA6D, 0xA6E, 0xA6F, 
				0xA70, 0xA71, 0xA72, 0xA73, 0xA74, 0xA75, 0xA76, 0xA77, 
				0xA78, 0xA79, 0xA7A, 0xA7B, 0xA7C, 0xA7D, 0xA7E, 0xA7F, 
				0xA80, 0xA81, 0xA82, 0xA83, 0xA84, 0xA85, 0xA86, 0xA87, 
				0xA88, 0xA89, 0xA8A, 0xA8B, 0xA8C, 0xA8D, 0xA8E, 0xA8F, 
				0xA90, 0xA91, 0xA92, 0xA93, 0xA94, 0xA95, 0xA96, 0xA97, 
				0xA98, 0xA99, 0xA9A, 0xA9B, 0xA9C, 0xA9D, 0xA9E, 0xA9F, 
				0xAA0, 0xAA1, 0xAA2, 0xAA3, 0xAA4, 0xAA5, 0xAA6, 0xAA7, 
				0xAA8, 0xAA9, 0xAAA, 0xAAB, 0xAAC, 0xAAD, 0xAAE, 0xAAF, 
				0xAB0, 0xAB1, 0xAB2, 0xAB3, 0xAB4, 0xAB5, 0xAB6, 0xAB7, 
				0xAB8, 0xAB9, 0xABA, 0xABB, 0xABC, 0xABD, 0xABE, 0xABF, 
				0xAC0, 0xAC1, 0xAC2, 0xAC3, 0xAC4, 0xAC5, 0xAC6, 0xAC7, 
				0xAC8, 0xAC9, 0xACA, 0xACB, 0xACC, 0xACD, 0xACE, 0xACF, 
				0xAD0, 0xAD1, 0xAD2, 0xAD3, 0xAD4, 0xAD5, 0xAD6, 0xAD7, 
				0xAD8, 0xAD9, 0xADA, 0xADB, 0xADC, 0xADD, 0xADE, 0xADF, 
				0xAE0, 0xAE1, 0xAE2, 0xAE3, 0xAE4, 0xAE5, 0xAE6, 0xAE7, 
				0xAE8, 0xAE9, 0xAEA, 0xAEB, 0xAEC, 0xAED, 0xAEE, 0xAEF, 
				0xAF0, 0xAF1, 0xAF2, 0xAF3, 0xAF4, 0xAF5, 0xAF6, 0xAF7, 
				0xAF8, 0xAF9, 0xAFA, 0xAFB, 0xAFC, 0xAFD, 0xAFE, 0xAFF, 
				0xB00, 0xB01, 0xB02, 0xB03, 0xB04, 0xB05, 0xB06, 0xB07, 
				0xB08, 0xB09, 0xB0A, 0xB0B, 0xB0C, 0xB0D, 0xB0E, 0xB0F, 
				0xB10, 0xB11, 0xB12, 0xB13, 0xB14, 0xB15, 0xB16, 0xB17, 
				0xB18, 0xB19, 0xB1A, 0xB1B, 0xB1C, 0xB1D, 0xB1E, 0xB1F, 
				0xB20, 0xB21, 0xB22, 0xB23, 0xB24, 0xB25, 0xB26, 0xB27, 
				0xB28, 0xB29, 0xB2A, 0xB2B, 0xB2C, 0xB2D, 0xB2E, 0xB2F, 
				0xB30, 0xB31, 0xB32, 0xB33, 0xB34, 0xB35, 0xB36, 0xB37, 
				0xB38, 0xB39, 0xB3A, 0xB3B, 0xB3C, 0xB3D, 0xB3E, 0xB3F, 
				0xB40, 0xB41, 0xB42, 0xB43, 0xB44, 0xB45, 0xB46, 0xB47, 
				0xB48, 0xB49, 0xB4A, 0xB4B, 0xB4C, 0xB4D, 0xB4E, 0xB4F, 
				0xB50, 0xB51, 0xB52, 0xB53, 0xB54, 0xB55, 0xB56, 0xB57, 
				0xB58, 0xB59, 0xB5A, 0xB5B, 0xB5C, 0xB5D, 0xB5E, 0xB5F, 
				0xB60, 0xB61, 0xB62, 0xB63, 0xB64, 0xB65, 0xB66, 0xB67, 
				0xB68, 0xB69, 0xB6A, 0xB6B, 0xB6C, 0xB6D, 0xB6E, 0xB6F, 
				0xB70, 0xB71, 0xB72, 0xB73, 0xB74, 0xB75, 0xB76, 0xB77, 
				0xB78, 0xB79, 0xB7A, 0xB7B, 0xB7C, 0xB7D, 0xB7E, 0xB7F, 
				0xB80, 0xB81, 0xB82, 0xB83, 0xB84, 0xB85, 0xB86, 0xB87, 
				0xB88, 0xB89, 0xB8A, 0xB8B, 0xB8C, 0xB8D, 0xB8E, 0xB8F, 
				0xB90, 0xB91, 0xB92, 0xB93, 0xB94, 0xB95, 0xB96, 0xB97, 
				0xB98, 0xB99, 0xB9A, 0xB9B, 0xB9C, 0xB9D, 0xB9E, 0xB9F, 
				0xBA0, 0xBA1, 0xBA2, 0xBA3, 0xBA4, 0xBA5, 0xBA6, 0xBA7, 
				0xBA8, 0xBA9, 0xBAA, 0xBAB, 0xBAC, 0xBAD, 0xBAE, 0xBAF, 
				0xBB0, 0xBB1, 0xBB2, 0xBB3, 0xBB4, 0xBB5, 0xBB6, 0xBB7, 
				0xBB8, 0xBB9, 0xBBA, 0xBBB, 0xBBC, 0xBBD, 0xBBE, 0xBBF, 
				0xBC0, 0xBC1, 0xBC2, 0xBC3, 0xBC4, 0xBC5, 0xBC6, 0xBC7, 
				0xBC8, 0xBC9, 0xBCA, 0xBCB, 0xBCC, 0xBCD, 0xBCE, 0xBCF, 
				0xBD0, 0xBD1, 0xBD2, 0xBD3, 0xBD4, 0xBD5, 0xBD6, 0xBD7, 
				0xBD8, 0xBD9, 0xBDA, 0xBDB, 0xBDC, 0xBDD, 0xBDE, 0xBDF, 
				0xBE0, 0xBE1, 0xBE2, 0xBE3, 0xBE4, 0xBE5, 0xBE6, 0xBE7, 
				0xBE8, 0xBE9, 0xBEA, 0xBEB, 0xBEC, 0xBED, 0xBEE, 0xBEF, 
				0xBF0, 0xBF1, 0xBF2, 0xBF3, 0xBF4, 0xBF5, 0xBF6, 0xBF7, 
				0xBF8, 0xBF9, 0xBFA, 0xBFB, 0xBFC, 0xBFD, 0xBFE, 0xBFF, 
				0xC00, 0xC01, 0xC02, 0xC03, 0xC04, 0xC05, 0xC06, 0xC07, 
				0xC08, 0xC09, 0xC0A, 0xC0B, 0xC0C, 0xC0D, 0xC0E, 0xC0F, 
				0xC10, 0xC11, 0xC12, 0xC13, 0xC14, 0xC15, 0xC16, 0xC17, 
				0xC18, 0xC19, 0xC1A, 0xC1B, 0xC1C, 0xC1D, 0xC1E, 0xC1F, 
				0xC20, 0xC21, 0xC22, 0xC23, 0xC24, 0xC25, 0xC26, 0xC27, 
				0xC28, 0xC29, 0xC2A, 0xC2B, 0xC2C, 0xC2D, 0xC2E, 0xC2F, 
				0xC30, 0xC31, 0xC32, 0xC33, 0xC34, 0xC35, 0xC36, 0xC37, 
				0xC38, 0xC39, 0xC3A, 0xC3B, 0xC3C, 0xC3D, 0xC3E, 0xC3F, 
				0xC40, 0xC41, 0xC42, 0xC43, 0xC44, 0xC45, 0xC46, 0xC47, 
				0xC48, 0xC49, 0xC4A, 0xC4B, 0xC4C, 0xC4D, 0xC4E, 0xC4F, 
				0xC50, 0xC51, 0xC52, 0xC53, 0xC54, 0xC55, 0xC56, 0xC57, 
				0xC58, 0xC59, 0xC5A, 0xC5B, 0xC5C, 0xC5D, 0xC5E, 0xC5F, 
				0xC60, 0xC61, 0xC62, 0xC63, 0xC64, 0xC65, 0xC66, 0xC67, 
				0xC68, 0xC69, 0xC6A, 0xC6B, 0xC6C, 0xC6D, 0xC6E, 0xC6F, 
				0xC70, 0xC71, 0xC72, 0xC73, 0xC74, 0xC75, 0xC76, 0xC77, 
				0xC78, 0xC79, 0xC7A, 0xC7B, 0xC7C, 0xC7D, 0xC7E, 0xC7F, 
				0xC80, 0xC81, 0xC82, 0xC83, 0xC84, 0xC85, 0xC86, 0xC87, 
				0xC88, 0xC89, 0xC8A, 0xC8B, 0xC8C, 0xC8D, 0xC8E, 0xC8F, 
				0xC90, 0xC91, 0xC92, 0xC93, 0xC94, 0xC95, 0xC96, 0xC97, 
				0xC98, 0xC99, 0xC9A, 0xC9B, 0xC9C, 0xC9D, 0xC9E, 0xC9F, 
				0xCA0, 0xCA1, 0xCA2, 0xCA3, 0xCA4, 0xCA5, 0xCA6, 0xCA7, 
				0xCA8, 0xCA9, 0xCAA, 0xCAB, 0xCAC, 0xCAD, 0xCAE, 0xCAF, 
				0xCB0, 0xCB1, 0xCB2, 0xCB3, 0xCB4, 0xCB5, 0xCB6, 0xCB7, 
				0xCB8, 0xCB9, 0xCBA, 0xCBB, 0xCBC, 0xCBD, 0xCBE, 0xCBF, 
				0xCC0, 0xCC1, 0xCC2, 0xCC3, 0xCC4, 0xCC5, 0xCC6, 0xCC7, 
				0xCC8, 0xCC9, 0xCCA, 0xCCB, 0xCCC, 0xCCD, 0xCCE, 0xCCF, 
				0xCD0, 0xCD1, 0xCD2, 0xCD3, 0xCD4, 0xCD5, 0xCD6, 0xCD7, 
				0xCD8, 0xCD9, 0xCDA, 0xCDB, 0xCDC, 0xCDD, 0xCDE, 0xCDF, 
				0xCE0, 0xCE1, 0xCE2, 0xCE3, 0xCE4, 0xCE5, 0xCE6, 0xCE7, 
				0xCE8, 0xCE9, 0xCEA, 0xCEB, 0xCEC, 0xCED, 0xCEE, 0xCEF, 
				0xCF0, 0xCF1, 0xCF2, 0xCF3, 0xCF4, 0xCF5, 0xCF6, 0xCF7, 
				0xCF8, 0xCF9, 0xCFA, 0xCFB, 0xCFC, 0xCFD, 0xCFE, 0xCFF, 
				0xD00, 0xD01, 0xD02, 0xD03, 0xD04, 0xD05, 0xD06, 0xD07, 
				0xD08, 0xD09, 0xD0A, 0xD0B, 0xD0C, 0xD0D, 0xD0E, 0xD0F, 
				0xD10, 0xD11, 0xD12, 0xD13, 0xD14, 0xD15, 0xD16, 0xD17, 
				0xD18, 0xD19, 0xD1A, 0xD1B, 0xD1C, 0xD1D, 0xD1E, 0xD1F, 
				0xD20, 0xD21, 0xD22, 0xD23, 0xD24, 0xD25, 0xD26, 0xD27, 
				0xD28, 0xD29, 0xD2A, 0xD2B, 0xD2C, 0xD2D, 0xD2E, 0xD2F, 
				0xD30, 0xD31, 0xD32, 0xD33, 0xD34, 0xD35, 0xD36, 0xD37, 
				0xD38, 0xD39, 0xD3A, 0xD3B, 0xD3C, 0xD3D, 0xD3E, 0xD3F, 
				0xD40, 0xD41, 0xD42, 0xD43, 0xD44, 0xD45, 0xD46, 0xD47, 
				0xD48, 0xD49, 0xD4A, 0xD4B, 0xD4C, 0xD4D, 0xD4E, 0xD4F, 
				0xD50, 0xD51, 0xD52, 0xD53, 0xD54, 0xD55, 0xD56, 0xD57, 
				0xD58, 0xD59, 0xD5A, 0xD5B, 0xD5C, 0xD5D, 0xD5E, 0xD5F, 
				0xD60, 0xD61, 0xD62, 0xD63, 0xD64, 0xD65, 0xD66, 0xD67, 
				0xD68, 0xD69, 0xD6A, 0xD6B, 0xD6C, 0xD6D, 0xD6E, 0xD6F, 
				0xD70, 0xD71, 0xD72, 0xD73, 0xD74, 0xD75, 0xD76, 0xD77, 
				0xD78, 0xD79, 0xD7A, 0xD7B, 0xD7C, 0xD7D, 0xD7E, 0xD7F, 
				0xD80, 0xD81, 0xD82, 0xD83, 0xD84, 0xD85, 0xD86, 0xD87, 
				0xD88, 0xD89, 0xD8A, 0xD8B, 0xD8C, 0xD8D, 0xD8E, 0xD8F, 
				0xD90, 0xD91, 0xD92, 0xD93, 0xD94, 0xD95, 0xD96, 0xD97, 
				0xD98, 0xD99, 0xD9A, 0xD9B, 0xD9C, 0xD9D, 0xD9E, 0xD9F, 
				0xDA0, 0xDA1, 0xDA2, 0xDA3, 0xDA4, 0xDA5, 0xDA6, 0xDA7, 
				0xDA8, 0xDA9, 0xDAA, 0xDAB, 0xDAC, 0xDAD, 0xDAE, 0xDAF, 
				0xDB0, 0xDB1, 0xDB2, 0xDB3, 0xDB4, 0xDB5, 0xDB6, 0xDB7, 
				0xDB8, 0xDB9, 0xDBA, 0xDBB, 0xDBC, 0xDBD, 0xDBE, 0xDBF, 
				0xDC0, 0xDC1, 0xDC2, 0xDC3, 0xDC4, 0xDC5, 0xDC6, 0xDC7, 
				0xDC8, 0xDC9, 0xDCA, 0xDCB, 0xDCC, 0xDCD, 0xDCE, 0xDCF, 
				0xDD0, 0xDD1, 0xDD2, 0xDD3, 0xDD4, 0xDD5, 0xDD6, 0xDD7, 
				0xDD8, 0xDD9, 0xDDA, 0xDDB, 0xDDC, 0xDDD, 0xDDE, 0xDDF, 
				0xDE0, 0xDE1, 0xDE2, 0xDE3, 0xDE4, 0xDE5, 0xDE6, 0xDE7, 
				0xDE8, 0xDE9, 0xDEA, 0xDEB, 0xDEC, 0xDED, 0xDEE, 0xDEF, 
				0xDF0, 0xDF1, 0xDF2, 0xDF3, 0xDF4, 0xDF5, 0xDF6, 0xDF7, 
				0xDF8, 0xDF9, 0xDFA, 0xDFB, 0xDFC, 0xDFD, 0xDFE, 0xDFF, 
				0xE00, 0xE01, 0xE02, 0xE03, 0xE04, 0xE05, 0xE06, 0xE07, 
				0xE08, 0xE09, 0xE0A, 0xE0B, 0xE0C, 0xE0D, 0xE0E, 0xE0F, 
				0xE10, 0xE11, 0xE12, 0xE13, 0xE14, 0xE15, 0xE16, 0xE17, 
				0xE18, 0xE19, 0xE1A, 0xE1B, 0xE1C, 0xE1D, 0xE1E, 0xE1F, 
				0xE20, 0xE21, 0xE22, 0xE23, 0xE24, 0xE25, 0xE26, 0xE27, 
				0xE28, 0xE29, 0xE2A, 0xE2B, 0xE2C, 0xE2D, 0xE2E, 0xE2F, 
				0xE30, 0xE31, 0xE32, 0xE33, 0xE34, 0xE35, 0xE36, 0xE37, 
				0xE38, 0xE39, 0xE3A, 0xE3B, 0xE3C, 0xE3D, 0xE3E, 0xE3F, 
				0xE40, 0xE41, 0xE42, 0xE43, 0xE44, 0xE45, 0xE46, 0xE47, 
				0xE48, 0xE49, 0xE4A, 0xE4B, 0xE4C, 0xE4D, 0xE4E, 0xE4F, 
				0xE50, 0xE51, 0xE52, 0xE53, 0xE54, 0xE55, 0xE56, 0xE57, 
				0xE58, 0xE59, 0xE5A, 0xE5B, 0xE5C, 0xE5D, 0xE5E, 0xE5F, 
				0xE60, 0xE61, 0xE62, 0xE63, 0xE64, 0xE65, 0xE66, 0xE67, 
				0xE68, 0xE69, 0xE6A, 0xE6B, 0xE6C, 0xE6D, 0xE6E, 0xE6F, 
				0xE70, 0xE71, 0xE72, 0xE73, 0xE74, 0xE75, 0xE76, 0xE77, 
				0xE78, 0xE79, 0xE7A, 0xE7B, 0xE7C, 0xE7D, 0xE7E, 0xE7F, 
				0xE80, 0xE81, 0xE82, 0xE83, 0xE84, 0xE85, 0xE86, 0xE87, 
				0xE88, 0xE89, 0xE8A, 0xE8B, 0xE8C, 0xE8D, 0xE8E, 0xE8F, 
				0xE90, 0xE91, 0xE92, 0xE93, 0xE94, 0xE95, 0xE96, 0xE97, 
				0xE98, 0xE99, 0xE9A, 0xE9B, 0xE9C, 0xE9D, 0xE9E, 0xE9F, 
				0xEA0, 0xEA1, 0xEA2, 0xEA3, 0xEA4, 0xEA5, 0xEA6, 0xEA7, 
				0xEA8, 0xEA9, 0xEAA, 0xEAB, 0xEAC, 0xEAD, 0xEAE, 0xEAF, 
				0xEB0, 0xEB1, 0xEB2, 0xEB3, 0xEB4, 0xEB5, 0xEB6, 0xEB7, 
				0xEB8, 0xEB9, 0xEBA, 0xEBB, 0xEBC, 0xEBD, 0xEBE, 0xEBF, 
				0xEC0, 0xEC1, 0xEC2, 0xEC3, 0xEC4, 0xEC5, 0xEC6, 0xEC7, 
				0xEC8, 0xEC9, 0xECA, 0xECB, 0xECC, 0xECD, 0xECE, 0xECF, 
				0xED0, 0xED1, 0xED2, 0xED3, 0xED4, 0xED5, 0xED6, 0xED7, 
				0xED8, 0xED9, 0xEDA, 0xEDB, 0xEDC, 0xEDD, 0xEDE, 0xEDF, 
				0xEE0, 0xEE1, 0xEE2, 0xEE3, 0xEE4, 0xEE5, 0xEE6, 0xEE7, 
				0xEE8, 0xEE9, 0xEEA, 0xEEB, 0xEEC, 0xEED, 0xEEE, 0xEEF, 
				0xEF0, 0xEF1, 0xEF2, 0xEF3, 0xEF4, 0xEF5, 0xEF6, 0xEF7, 
				0xEF8, 0xEF9, 0xEFA, 0xEFB, 0xEFC, 0xEFD, 0xEFE, 0xEFF, 
				0xF00, 0xF01, 0xF02, 0xF03, 0xF04, 0xF05, 0xF06, 0xF07, 
				0xF08, 0xF09, 0xF0A, 0xF0B, 0xF0C, 0xF0D, 0xF0E, 0xF0F, 
				0xF10, 0xF11, 0xF12, 0xF13, 0xF14, 0xF15, 0xF16, 0xF17, 
				0xF18, 0xF19, 0xF1A, 0xF1B, 0xF1C, 0xF1D, 0xF1E, 0xF1F, 
				0xF20, 0xF21, 0xF22, 0xF23, 0xF24, 0xF25, 0xF26, 0xF27, 
				0xF28, 0xF29, 0xF2A, 0xF2B, 0xF2C, 0xF2D, 0xF2E, 0xF2F, 
				0xF30, 0xF31, 0xF32, 0xF33, 0xF34, 0xF35, 0xF36, 0xF37, 
				0xF38, 0xF39, 0xF3A, 0xF3B, 0xF3C, 0xF3D, 0xF3E, 0xF3F, 
				0xF40, 0xF41, 0xF42, 0xF43, 0xF44, 0xF45, 0xF46, 0xF47, 
				0xF48, 0xF49, 0xF4A, 0xF4B, 0xF4C, 0xF4D, 0xF4E, 0xF4F, 
				0xF50, 0xF51, 0xF52, 0xF53, 0xF54, 0xF55, 0xF56, 0xF57, 
				0xF58, 0xF59, 0xF5A, 0xF5B, 0xF5C, 0xF5D, 0xF5E, 0xF5F, 
				0xF60, 0xF61, 0xF62, 0xF63, 0xF64, 0xF65, 0xF66, 0xF67, 
				0xF68, 0xF69, 0xF6A, 0xF6B, 0xF6C, 0xF6D, 0xF6E, 0xF6F, 
				0xF70, 0xF71, 0xF72, 0xF73, 0xF74, 0xF75, 0xF76, 0xF77, 
				0xF78, 0xF79, 0xF7A, 0xF7B, 0xF7C, 0xF7D, 0xF7E, 0xF7F, 
				0xF80, 0xF81, 0xF82, 0xF83, 0xF84, 0xF85, 0xF86, 0xF87, 
				0xF88, 0xF89, 0xF8A, 0xF8B, 0xF8C, 0xF8D, 0xF8E, 0xF8F, 
				0xF90, 0xF91, 0xF92, 0xF93, 0xF94, 0xF95, 0xF96, 0xF97, 
				0xF98, 0xF99, 0xF9A, 0xF9B, 0xF9C, 0xF9D, 0xF9E, 0xF9F, 
				0xFA0, 0xFA1, 0xFA2, 0xFA3, 0xFA4, 0xFA5, 0xFA6, 0xFA7, 
				0xFA8, 0xFA9, 0xFAA, 0xFAB, 0xFAC, 0xFAD, 0xFAE, 0xFAF, 
				0xFB0, 0xFB1, 0xFB2, 0xFB3, 0xFB4, 0xFB5, 0xFB6, 0xFB7, 
				0xFB8, 0xFB9, 0xFBA, 0xFBB, 0xFBC, 0xFBD, 0xFBE, 0xFBF, 
				0xFC0, 0xFC1, 0xFC2, 0xFC3, 0xFC4, 0xFC5, 0xFC6, 0xFC7, 
				0xFC8, 0xFC9, 0xFCA, 0xFCB, 0xFCC, 0xFCD, 0xFCE, 0xFCF, 
				0xFD0, 0xFD1, 0xFD2, 0xFD3, 0xFD4, 0xFD5, 0xFD6, 0xFD7, 
				0xFD8, 0xFD9, 0xFDA, 0xFDB, 0xFDC, 0xFDD, 0xFDE, 0xFDF, 
				0xFE0, 0xFE1, 0xFE2, 0xFE3, 0xFE4, 0xFE5, 0xFE6, 0xFE7, 
				0xFE8, 0xFE9, 0xFEA, 0xFEB, 0xFEC, 0xFED, 0xFEE, 0xFEF, 
				0xFF0, 0xFF1, 0xFF2, 0xFF3, 0xFF4, 0xFF5, 0xFF6, 0xFF7, 
				0xFF8, 0xFF9, 0xFFA, 0xFFB, 0xFFC, 0xFFD, 0xFFE, 0xFFF
			},
			new int[] {
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x060, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x0C0, 
				0x000, 0x0C0, 0x0C0, 0x0E0, 0x0E0, 0x0F0, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x040, 0x060, 0x060, 0x070, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x060, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x100, 0x100, 0x180, 0x180, 0x180, 
				0x100, 0x180, 0x180, 0x180, 0x180, 0x1C0, 0x1C0, 0x1C0, 
				0x1C0, 0x1C0, 0x1E0, 0x1E0, 0x1E0, 0x3F0, 0x3F8, 0x3FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x040, 0x060, 0x070, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x080, 0x000, 0x080, 0x0C0, 0x0C0, 
				0x0C0, 0x0C0, 0x0C0, 0x1E0, 0x1E0, 0x1F0, 0x1F8, 0x1FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x040, 0x040, 0x0E0, 0x0E0, 0x0F0, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x020, 0x070, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x200, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x200, 0x200, 0x200, 
				0x200, 0x200, 0x300, 0x300, 0x300, 0x300, 0x300, 0x31C, 
				0x200, 0x300, 0x300, 0x300, 0x300, 0x300, 0x300, 0x300, 
				0x300, 0x300, 0x380, 0x380, 0x380, 0x380, 0x380, 0x388, 
				0x380, 0x380, 0x380, 0x3C0, 0x3C0, 0x3C0, 0x3C0, 0x7C0, 
				0x3C0, 0x7C0, 0x7E0, 0x7E0, 0x7E0, 0x7F0, 0x7F8, 0x7FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x060, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x0C0, 
				0x000, 0x0C0, 0x0C0, 0x0E0, 0x0E0, 0x0F0, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x040, 0x060, 0x060, 0x070, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x060, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x100, 0x100, 0x180, 0x180, 0x180, 
				0x100, 0x180, 0x180, 0x180, 0x180, 0x1C0, 0x1C0, 0x1C0, 
				0x1C0, 0x1C0, 0x1E0, 0x1E0, 0x1E0, 0x3F0, 0x3F8, 0x3FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x040, 0x060, 0x070, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x080, 0x000, 0x080, 0x0C0, 0x0C0, 
				0x0C0, 0x0C0, 0x0C0, 0x1E0, 0x1E0, 0x1F0, 0x1F8, 0x1FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x020, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x010, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x040, 0x040, 0x0E0, 0x0E0, 0x0F0, 0x0F0, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x020, 0x070, 0x070, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x030, 0x03C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x200, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x200, 0x200, 0x200, 
				0x200, 0x200, 0x300, 0x300, 0x300, 0x300, 0x300, 0x31C, 
				0x200, 0x300, 0x300, 0x300, 0x300, 0x300, 0x300, 0x300, 
				0x300, 0x300, 0x380, 0x380, 0x380, 0x380, 0x380, 0x388, 
				0x380, 0x380, 0x380, 0x3C0, 0x3C0, 0x3C0, 0x3C0, 0x7C0, 
				0x3C0, 0x7C0, 0x7E0, 0x7E0, 0x7E0, 0x7F0, 0x7F8, 0x7FC
			},
			new int[] {
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 
				0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF, 0xFFF
			},
			new int[] {
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000
			},
			new int[] {
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x003, 0x000, 0x000, 0x00E, 0x07F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x06F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x077, 
				0x000, 0x000, 0x000, 0x0FB, 0x000, 0x0FD, 0x1FE, 0x1FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x02F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x077, 
				0x000, 0x000, 0x000, 0x0FB, 0x000, 0x0FD, 0x0FE, 0x2FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x037, 
				0x000, 0x000, 0x000, 0x07B, 0x000, 0x07D, 0x17E, 0x37F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x017, 
				0x000, 0x000, 0x000, 0x0BB, 0x000, 0x3BD, 0x3BE, 0x3BF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x107, 
				0x000, 0x000, 0x000, 0x3DB, 0x000, 0x3DD, 0x3DE, 0x3DF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x3C3, 
				0x000, 0x000, 0x000, 0x3E1, 0x000, 0x3E8, 0x3EC, 0x3EF, 
				0x000, 0x000, 0x000, 0x3F0, 0x300, 0x3F0, 0x3F0, 0x3F7, 
				0x380, 0x3F8, 0x3F8, 0x3FB, 0x3F8, 0x3FD, 0x3FE, 0x3FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x03F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x003, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x037, 
				0x000, 0x000, 0x000, 0x07B, 0x000, 0x0FD, 0x0FE, 0x4FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x017, 
				0x000, 0x000, 0x000, 0x03B, 0x000, 0x07D, 0x07E, 0x57F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x01B, 0x000, 0x4BD, 0x5BE, 0x5BF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x407, 
				0x000, 0x000, 0x000, 0x503, 0x000, 0x5DD, 0x5DE, 0x5DF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x503, 
				0x000, 0x000, 0x000, 0x5C0, 0x000, 0x5E0, 0x5EC, 0x5EF, 
				0x000, 0x000, 0x400, 0x5E0, 0x400, 0x5F0, 0x5F0, 0x5F7, 
				0x500, 0x5F0, 0x5F8, 0x5FB, 0x5F8, 0x5FD, 0x5FE, 0x5FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x001, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x01B, 0x000, 0x43D, 0x47E, 0x67F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x00F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x407, 
				0x000, 0x000, 0x000, 0x403, 0x000, 0x61D, 0x6BE, 0x6BF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x407, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x403, 
				0x000, 0x000, 0x000, 0x601, 0x000, 0x680, 0x6DC, 0x6DF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x601, 
				0x000, 0x000, 0x000, 0x680, 0x400, 0x6C0, 0x6E0, 0x6EF, 
				0x000, 0x400, 0x400, 0x6C0, 0x600, 0x6E0, 0x6F0, 0x6F7, 
				0x600, 0x6F0, 0x6F0, 0x6FB, 0x6F8, 0x6FD, 0x6FE, 0x6FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x007, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x407, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x403, 
				0x000, 0x000, 0x000, 0x603, 0x000, 0x600, 0x71E, 0x73F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x403, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x601, 
				0x000, 0x000, 0x400, 0x700, 0x400, 0x700, 0x700, 0x75F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x400, 0x700, 
				0x000, 0x400, 0x400, 0x700, 0x600, 0x700, 0x740, 0x76F, 
				0x000, 0x400, 0x600, 0x700, 0x600, 0x740, 0x760, 0x777, 
				0x700, 0x760, 0x770, 0x77B, 0x770, 0x77D, 0x77E, 0x77F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x601, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x400, 0x400, 0x700, 
				0x000, 0x400, 0x400, 0x700, 0x600, 0x780, 0x780, 0x79F, 
				0x000, 0x000, 0x000, 0x400, 0x000, 0x400, 0x400, 0x700, 
				0x000, 0x400, 0x600, 0x780, 0x600, 0x780, 0x780, 0x7AF, 
				0x000, 0x600, 0x600, 0x780, 0x700, 0x780, 0x780, 0x7B7, 
				0x700, 0x780, 0x7A0, 0x7BB, 0x7B0, 0x7BD, 0x7BE, 0x7BF, 
				0x000, 0x000, 0x000, 0x400, 0x000, 0x600, 0x600, 0x700, 
				0x400, 0x600, 0x600, 0x780, 0x700, 0x780, 0x7C0, 0x7CF, 
				0x400, 0x600, 0x700, 0x780, 0x700, 0x7C0, 0x7C0, 0x7D7, 
				0x700, 0x7C0, 0x7C0, 0x7DB, 0x7C0, 0x7DD, 0x7DE, 0x7DF, 
				0x400, 0x700, 0x700, 0x7C0, 0x700, 0x7C0, 0x7C0, 0x7E7, 
				0x780, 0x7C0, 0x7E0, 0x7EB, 0x7E0, 0x7ED, 0x7EE, 0x7EF, 
				0x780, 0x7E0, 0x7E0, 0x7F3, 0x7E0, 0x7F5, 0x7F6, 0x7F7, 
				0x7F0, 0x7F8, 0x7FA, 0x7FB, 0x7FC, 0x7FD, 0x7FE, 0x7FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x807, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 0x803, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x801, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x83F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x803, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x801, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x81F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x81F, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x837, 
				0x800, 0x800, 0x800, 0x87B, 0x800, 0x8FD, 0x8FE, 0x8FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x801, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x81F, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x81F, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x817, 
				0x800, 0x800, 0x800, 0x83B, 0x800, 0x87D, 0x87E, 0x97F, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x81B, 0x800, 0x9BD, 0x9BE, 0x9BF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x903, 0x800, 0x9DC, 0x9DE, 0x9DF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x903, 
				0x800, 0x800, 0x800, 0x9C0, 0x800, 0x9E0, 0x9E8, 0x9EF, 
				0x800, 0x800, 0x800, 0x9E0, 0x800, 0x9F0, 0x9F0, 0x9F7, 
				0x900, 0x9F0, 0x9F8, 0x9FB, 0x9F8, 0x9FD, 0x9FE, 0x9FF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x801, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x81F, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x81B, 0x800, 0x83D, 0xA7E, 0xA7F, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0xA03, 0x800, 0xA1D, 0xABE, 0xABF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA03, 
				0x800, 0x800, 0x800, 0xA01, 0x800, 0xA80, 0xADC, 0xADF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA01, 
				0x800, 0x800, 0x800, 0xA80, 0x800, 0xAC0, 0xAE0, 0xAEF, 
				0x800, 0x800, 0xA00, 0xAC0, 0xA00, 0xAE0, 0xAF0, 0xAF7, 
				0xA00, 0xAF0, 0xAF0, 0xAFB, 0xAF8, 0xAFD, 0xAFE, 0xAFF, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA03, 
				0x800, 0x800, 0x800, 0xA01, 0x800, 0xB00, 0xB1C, 0xB3F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA03, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA01, 
				0x800, 0x800, 0x800, 0xB00, 0x800, 0xB00, 0xB00, 0xB5F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xB00, 
				0x800, 0x800, 0x800, 0xB00, 0xA00, 0xB00, 0xB40, 0xB6F, 
				0x800, 0xA00, 0xA00, 0xB00, 0xA00, 0xB40, 0xB60, 0xB77, 
				0xB00, 0xB60, 0xB70, 0xB7B, 0xB70, 0xB7D, 0xB7E, 0xB7F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA01, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xB00, 
				0x800, 0x800, 0x800, 0xB00, 0xA00, 0xB80, 0xB80, 0xB9F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xA00, 0xB00, 
				0x800, 0xA00, 0xA00, 0xB80, 0xA00, 0xB80, 0xB80, 0xBAF, 
				0x800, 0xA00, 0xA00, 0xB80, 0xB00, 0xB80, 0xB80, 0xBB7, 
				0xB00, 0xB80, 0xBA0, 0xBBB, 0xBB0, 0xBBD, 0xBBE, 0xBBF, 
				0x800, 0x800, 0x800, 0xA00, 0x800, 0xA00, 0xA00, 0xB00, 
				0x800, 0xA00, 0xA00, 0xB80, 0xB00, 0xB80, 0xBC0, 0xBCF, 
				0x800, 0xA00, 0xB00, 0xB80, 0xB00, 0xBC0, 0xBC0, 0xBD7, 
				0xB00, 0xBC0, 0xBC0, 0xBDB, 0xBC0, 0xBDD, 0xBDE, 0xBDF, 
				0xA00, 0xB00, 0xB00, 0xBC0, 0xB00, 0xBC0, 0xBC0, 0xBE7, 
				0xB80, 0xBC0, 0xBE0, 0xBEB, 0xBE0, 0xBED, 0xBEE, 0xBEF, 
				0xB80, 0xBE0, 0xBE0, 0xBF3, 0xBE0, 0xBF5, 0xBF6, 0xBF7, 
				0xBF0, 0xBF8, 0xBFA, 0xBFB, 0xBFC, 0xBFD, 0xBFE, 0xBFF, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x000, 0x000, 0x000, 0x800, 0x000, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x80F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC07, 
				0x800, 0x800, 0x800, 0xC0B, 0x800, 0xC1D, 0xC3E, 0xC7F, 
				0x000, 0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x807, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC07, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC03, 
				0x800, 0x800, 0x800, 0xC03, 0x800, 0xC00, 0xC1E, 0xCBF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC03, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC01, 
				0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xC00, 0xC00, 0xCDF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 0xC00, 0xC00, 
				0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xC80, 0xCC0, 0xCEF, 
				0x800, 0xC00, 0xC00, 0xC80, 0xC00, 0xCC0, 0xCE0, 0xCF7, 
				0xC00, 0xCE0, 0xCF0, 0xCFB, 0xCF0, 0xCFD, 0xCFE, 0xCFF, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC07, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC03, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC03, 
				0x800, 0x800, 0xC00, 0xC01, 0xC00, 0xC00, 0xC00, 0xD3F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 0xC03, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 0xC00, 0xC01, 
				0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xD00, 0xD00, 0xD5F, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xC00, 
				0x800, 0xC00, 0xC00, 0xD00, 0xC00, 0xD00, 0xD00, 0xD6F, 
				0xC00, 0xC00, 0xC00, 0xD00, 0xC00, 0xD00, 0xD40, 0xD77, 
				0xC00, 0xD40, 0xD60, 0xD7B, 0xD70, 0xD7D, 0xD7E, 0xD7F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xC01, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xC00, 
				0x800, 0xC00, 0xC00, 0xD00, 0xC00, 0xD00, 0xD00, 0xD9F, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xD00, 
				0xC00, 0xC00, 0xC00, 0xD00, 0xC00, 0xD80, 0xD80, 0xDAF, 
				0xC00, 0xC00, 0xC00, 0xD80, 0xC00, 0xD80, 0xD80, 0xDB7, 
				0xD00, 0xD80, 0xD80, 0xDBB, 0xDA0, 0xDBD, 0xDBE, 0xDBF, 
				0x800, 0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xC00, 0xD00, 
				0xC00, 0xC00, 0xC00, 0xD00, 0xC00, 0xD80, 0xD80, 0xDCF, 
				0xC00, 0xC00, 0xC00, 0xD80, 0xD00, 0xD80, 0xDC0, 0xDD7, 
				0xD00, 0xDC0, 0xDC0, 0xDDB, 0xDC0, 0xDDD, 0xDDE, 0xDDF, 
				0xC00, 0xD00, 0xD00, 0xD80, 0xD00, 0xDC0, 0xDC0, 0xDE7, 
				0xD00, 0xDC0, 0xDC0, 0xDEB, 0xDE0, 0xDED, 0xDEE, 0xDEF, 
				0xD80, 0xDC0, 0xDE0, 0xDF3, 0xDE0, 0xDF5, 0xDF6, 0xDF7, 
				0xDE0, 0xDF8, 0xDFA, 0xDFB, 0xDFC, 0xDFD, 0xDFE, 0xDFF, 
				0x000, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC07, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC03, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 0xC00, 0xE01, 
				0x800, 0xC00, 0xC00, 0xE00, 0xC00, 0xE00, 0xE00, 0xE3F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 0xC00, 0xE01, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xE00, 
				0x800, 0xC00, 0xC00, 0xE00, 0xC00, 0xE00, 0xE00, 0xE5F, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xE00, 
				0xC00, 0xC00, 0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE6F, 
				0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE77, 
				0xE00, 0xE00, 0xE40, 0xE7B, 0xE60, 0xE7D, 0xE7E, 0xE7F, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xE00, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xE00, 
				0xC00, 0xC00, 0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE9F, 
				0x800, 0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xE00, 0xE00, 
				0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE80, 0xEAF, 
				0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE80, 0xE80, 0xEB7, 
				0xE00, 0xE80, 0xE80, 0xEBB, 0xE80, 0xEBD, 0xEBE, 0xEBF, 
				0x800, 0xC00, 0xC00, 0xE00, 0xC00, 0xE00, 0xE00, 0xE00, 
				0xC00, 0xE00, 0xE00, 0xE00, 0xE00, 0xE80, 0xE80, 0xECF, 
				0xC00, 0xE00, 0xE00, 0xE80, 0xE00, 0xE80, 0xE80, 0xED7, 
				0xE00, 0xE80, 0xEC0, 0xEDB, 0xEC0, 0xEDD, 0xEDE, 0xEDF, 
				0xE00, 0xE00, 0xE00, 0xE80, 0xE00, 0xE80, 0xEC0, 0xEE7, 
				0xE00, 0xEC0, 0xEC0, 0xEEB, 0xEC0, 0xEED, 0xEEE, 0xEEF, 
				0xE80, 0xEC0, 0xEC0, 0xEF3, 0xEE0, 0xEF4, 0xEF6, 0xEF7, 
				0xEE0, 0xEF8, 0xEF8, 0xEFB, 0xEFC, 0xEFD, 0xEFE, 0xEFF, 
				0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0x800, 0xC00, 
				0x800, 0x800, 0x800, 0xC00, 0x800, 0xC00, 0xC00, 0xE00, 
				0x800, 0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xC00, 0xE00, 
				0xC00, 0xE00, 0xE00, 0xF00, 0xE00, 0xF00, 0xF00, 0xF1F, 
				0x800, 0xC00, 0xC00, 0xC00, 0xC00, 0xE00, 0xE00, 0xF00, 
				0xC00, 0xE00, 0xE00, 0xF00, 0xE00, 0xF00, 0xF00, 0xF2F, 
				0xC00, 0xE00, 0xE00, 0xF00, 0xE00, 0xF00, 0xF00, 0xF37, 
				0xF00, 0xF00, 0xF00, 0xF3B, 0xF00, 0xF3D, 0xF3E, 0xF3F, 
				0x800, 0xC00, 0xC00, 0xE00, 0xC00, 0xE00, 0xE00, 0xF00, 
				0xC00, 0xE00, 0xE00, 0xF00, 0xE00, 0xF00, 0xF00, 0xF4F, 
				0xE00, 0xE00, 0xE00, 0xF00, 0xF00, 0xF00, 0xF00, 0xF57, 
				0xF00, 0xF00, 0xF00, 0xF5B, 0xF40, 0xF5D, 0xF5E, 0xF5F, 
				0xE00, 0xF00, 0xF00, 0xF00, 0xF00, 0xF00, 0xF00, 0xF67, 
				0xF00, 0xF00, 0xF40, 0xF6B, 0xF40, 0xF6D, 0xF6E, 0xF6F, 
				0xF00, 0xF40, 0xF40, 0xF71, 0xF40, 0xF74, 0xF74, 0xF77, 
				0xF60, 0xF78, 0xF78, 0xF7B, 0xF7C, 0xF7D, 0xF7E, 0xF7F, 
				0xC00, 0xC00, 0xC00, 0xE00, 0xC00, 0xE00, 0xE00, 0xF00, 
				0xE00, 0xE00, 0xE00, 0xF00, 0xF00, 0xF80, 0xF80, 0xF8F, 
				0xE00, 0xE00, 0xF00, 0xF80, 0xF00, 0xF80, 0xF80, 0xF97, 
				0xF00, 0xF80, 0xF80, 0xF9B, 0xF80, 0xF9D, 0xF9E, 0xF9F, 
				0xE00, 0xF00, 0xF00, 0xF80, 0xF00, 0xF80, 0xF80, 0xFA7, 
				0xF00, 0xF80, 0xF80, 0xFA9, 0xF80, 0xFAC, 0xFAC, 0xFAF, 
				0xF80, 0xF80, 0xF80, 0xFB0, 0xF80, 0xFB0, 0xFB4, 0xFB7, 
				0xF80, 0xFB8, 0xFB8, 0xFBB, 0xFBC, 0xFBD, 0xFBE, 0xFBF, 
				0xE00, 0xF00, 0xF00, 0xF80, 0xF00, 0xF80, 0xF80, 0xFC1, 
				0xF00, 0xF80, 0xFC0, 0xFC0, 0xFC0, 0xFC0, 0xFC8, 0xFCF, 
				0xF80, 0xFC0, 0xFC0, 0xFD0, 0xFC0, 0xFD0, 0xFD0, 0xFD7, 
				0xFC0, 0xFD0, 0xFD8, 0xFDB, 0xFD8, 0xFDD, 0xFDE, 0xFDF, 
				0xF80, 0xFC0, 0xFC0, 0xFE0, 0xFC0, 0xFE0, 0xFE0, 0xFE7, 
				0xFC0, 0xFE0, 0xFE8, 0xFEB, 0xFE8, 0xFED, 0xFEE, 0xFEF, 
				0xFE0, 0xFF0, 0xFF0, 0xFF3, 0xFF0, 0xFF5, 0xFF6, 0xFF7, 
				0xFF8, 0xFF9, 0xFFA, 0xFFB, 0xFFC, 0xFFD, 0xFFE, 0xFFF
			},
			new int[] {
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x780, 
				0x000, 0x000, 0x000, 0x7C0, 0x380, 0x7E0, 0x7F0, 0x7FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x018, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x0FC, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x07C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x01C, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x008, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 
				0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x000, 0x780, 
				0x000, 0x000, 0x000, 0x7C0, 0x380, 0x7E0, 0x7F0, 0x7FC
			}
		};

        static public Sid Create(int newSampleRate, Region newRegion)
        {
            return new Sid(waveTable, newSampleRate, newRegion);
        }
	}
}
